// This code conforms with the UFC specification version 2017.2.0
// and was automatically generated by FFC version 2017.2.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 },
          { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 },
          { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.2915026221291885, 0.0, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 },
          { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 },
          { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291885, -4.6106168678100405e-14, -2.9933259094191556, 13.662601021279457, 0.0, 0.6110100926607791, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906181, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999916, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.0583005244258321, 0.3055050463303882, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998244, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.8073922282301202, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688765, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.8284271247462294, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.9999999999999996) + dof_values[4] * (K[2] * -2.9999999999999996) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.9999999999999987) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000018) + dof_values[1] * (K[2] * -3.0000000000000044) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0000000000000004 + K[2] * -3.0000000000000036) + dof_values[8] * (K[0] * 3.0000000000000004 + K[2] * 3.0000000000000053);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.999999999999996) + dof_values[2] * (K[0] * -2.9999999999999982) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999973 + K[2] * -3.0) + dof_values[5] * (K[0] * 2.9999999999999964 + K[2] * 3.000000000000001);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.9999999999999996) + dof_values[4] * (K[2 + 1] * -2.9999999999999996) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.9999999999999987) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000018) + dof_values[1] * (K[2 + 1] * -3.0000000000000044) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0000000000000004 + K[2 + 1] * -3.0000000000000036) + dof_values[8] * (K[1] * 3.0000000000000004 + K[2 + 1] * 3.0000000000000053);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.999999999999996) + dof_values[2] * (K[1] * -2.9999999999999982) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999973 + K[2 + 1] * -3.0) + dof_values[5] * (K[1] * 2.9999999999999964 + K[2 + 1] * 3.000000000000001);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333347 * sp[33] + 0.3583333333333403 * sp[34] + -0.6083333333333348 * sp[28] + -0.608333333333329 * sp[31] + 0.3583333333333403 * sp[34] + 0.8583333333333483 * sp[35] + -1.875000000000023 * sp[29] + -0.6083333333333397 * sp[32] + -0.6083333333333348 * sp[28] + -1.875000000000023 * sp[29] + 6.191666666666694 * sp[26] + 1.691666666666663 * sp[27] + -0.608333333333329 * sp[31] + -0.6083333333333397 * sp[32] + 1.691666666666663 * sp[27] + 0.6333333333333291 * sp[30];
    A[1] = -2.016666666666673 * sp[33] + 1.116666666666664 * sp[34] + -0.6166666666666692 * sp[28] + -0.6166666666666804 * sp[31] + 0.2833333333333339 * sp[34] + -0.8000000000000103 * sp[35] + sp[29] + -0.6166666666666807 * sp[32] + 0.2166666666666656 * sp[28] + 1.666666666666685 * sp[29] + -3.466666666666688 * sp[26] + 2.783333333333351 * sp[27] + 0.2166666666666593 * sp[31] + 0.2166666666666741 * sp[32] + -0.7166666666666668 * sp[27] + 0.8166666666666623 * sp[30];
    A[2] = -0.03333333333332916 * sp[33] + -0.8916666666666657 * sp[34] + -0.1916666666666679 * sp[28] + -0.1916666666666637 * sp[31] + 0.4416666666666709 * sp[34] + 1.275000000000009 * sp[35] + -0.7916666666666765 * sp[29] + -0.1916666666666619 * sp[32] + -0.1916666666666685 * sp[28] + -0.7916666666666725 * sp[29] + 1.275000000000009 * sp[26] + -0.8916666666666733 * sp[27] + -0.1916666666666696 * sp[31] + -0.1916666666666731 * sp[32] + 0.4416666666666692 * sp[27] + -0.03333333333332877 * sp[30];
    A[3] = -1.591666666666677 * sp[33] + -0.6500000000000061 * sp[34] + -2.28333333333335 * sp[28] + -0.6500000000000127 * sp[31] + -0.9416666666666769 * sp[34] + -1.295833333333348 * sp[35] + -0.112500000000004 * sp[29] + -0.4666666666666739 * sp[32] + 0.6916666666666684 * sp[28] + 1.520833333333348 * sp[29] + -1.095833333333332 * sp[26] + -0.2666666666666587 * sp[27] + 0.6916666666666678 * sp[31] + 0.6916666666666722 * sp[32] + 0.6916666666666669 * sp[27] + 0.5083333333333385 * sp[30];
    A[4] = -0.06666666666666266 * sp[33] + -0.5333333333333306 * sp[34] + -0.09999999999999098 * sp[28] + -0.5333333333333307 * sp[31] + 0.8833333333333411 * sp[34] + 1.675000000000012 * sp[35] + 0.1416666666666681 * sp[29] + 0.9333333333333305 * sp[32] + -0.3833333333333338 * sp[28] + -0.9583333333333403 * sp[29] + 0.4416666666666673 * sp[26] + -0.133333333333332 * sp[27] + -0.3833333333333384 * sp[31] + -0.3833333333333411 * sp[32] + -0.383333333333338 * sp[27] + -0.6000000000000051 * sp[30];
    A[5] = -1.008333333333333 * sp[33] + 1.183333333333333 * sp[34] + -2.116666666666671 * sp[28] + 1.183333333333333 * sp[31] + 0.1416666666666675 * sp[34] + -0.837500000000007 * sp[35] + 0.5125000000000047 * sp[29] + -0.4666666666666676 * sp[32] + 0.1083333333333307 * sp[28] + 1.145833333333343 * sp[29] + -0.6375000000000097 * sp[26] + 0.40000000000001 * sp[27] + 0.1083333333333287 * sp[31] + 0.1083333333333392 * sp[32] + 0.1083333333333248 * sp[27] + 0.09166666666667571 * sp[30];
    A[6] = -1.091666666666674 * sp[33] + -1.108333333333342 * sp[34] + -1.108333333333335 * sp[28] + -1.108333333333336 * sp[31] + -0.7333333333333441 * sp[34] + -0.3624999999999955 * sp[35] + -1.479166666666684 * sp[29] + -1.108333333333341 * sp[32] + 2.133333333333345 * sp[28] + 1.154166666666652 * sp[29] + 3.170833333333344 * sp[26] + 2.191666666666666 * sp[27] + 1.149999999999999 * sp[31] + 1.116666666666661 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333332 * sp[30];
    A[7] = 2.600000000000012 * sp[33] + 1.216666666666668 * sp[34] + 1.216666666666667 * sp[28] + 1.216666666666664 * sp[31] + 1.466666666666686 * sp[34] + 0.3083333333333405 * sp[35] + 2.375000000000028 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333356 * sp[28] + -1.058333333333326 * sp[29] + -7.258333333333363 * sp[26] + -3.383333333333328 * sp[27] + -2.133333333333325 * sp[31] + -0.8999999999999939 * sp[32] + -2.133333333333328 * sp[27] + -1.266666666666658 * sp[30];
    A[8] = -1.50833333333334 * sp[33] + 0.3083333333333479 * sp[34] + 0.3083333333333363 * sp[28] + 0.3083333333333468 * sp[31] + -0.7333333333333422 * sp[34] + 0.7625000000000104 * sp[35] + -1.187500000000014 * sp[29] + 0.3083333333333421 * sp[32] + 2.80000000000001 * sp[28] + -2.887500000000012 * sp[29] + 4.295833333333356 * sp[26] + -1.391666666666683 * sp[27] + 0.9833333333333261 * sp[31] + -0.7166666666666609 * sp[32] + 0.9833333333333314 * sp[27] + -0.4083333333333338 * sp[30];
    A[9] = 1.649915822768648 * sp[33] + 0.4714045207910273 * sp[34] + -5.185449728701356 * sp[28] + -5.185449728701383 * sp[31] + 3.064129385141741 * sp[34] + 1.767766952966346 * sp[35] + -3.889087296526053 * sp[29] + -5.185449728701424 * sp[32] + -1.649915822768629 * sp[28] + 5.06759859850361 * sp[29] + 10.72445284799599 * sp[26] + 17.44196726926821 * sp[27] + -1.649915822768631 * sp[31] + -0.2357022603955496 * sp[32] + 4.006938426723752 * sp[27] + 5.892556509887863 * sp[30];
    A[10] = 10.96965511460293 * sp[33] + 0.7216878364869752 * sp[34] + -10.5366424127107 * sp[28] + -10.53664241271074 * sp[31] + 0.1443375672973413 * sp[34] + -1.732050807568894 * sp[35] + -8.660254037844483 * sp[29] + -10.53664241271079 * sp[32] + 0.7216878364870857 * sp[28] + 11.54700538379247 * sp[29] + 18.47520861406806 * sp[26] + 29.30052616137358 * sp[27] + 0.7216878364870798 * sp[31] + 5.051814855409184 * sp[32] + 7.649891066762525 * sp[27] + 10.96965511460285 * sp[30];
    A[11] = -6.833333333333346 * sp[33] + 1.583333333333338 * sp[34] + 0.08333333333333037 * sp[28] + 0.0833333333333437 * sp[31] + 2.416666666666682 * sp[34] + 3.75 * sp[35] + -1.250000000000009 * sp[29] + 0.08333333333338611 * sp[32] + 0.08333333333332001 * sp[28] + -4.916666666666647 * sp[29] + -5.916666666666699 * sp[26] + -10.91666666666671 * sp[27] + 0.08333333333330037 * sp[31] + 0.5833333333333779 * sp[32] + -0.9166666666666465 * sp[27] + -1.833333333333291 * sp[30];
    A[12] = 5.892556509887893 * sp[33] + -1.649915822768612 * sp[34] + 16.73486048808169 * sp[28] + 4.006938426723798 * sp[31] + -3.299831645537247 * sp[34] + -2.474873734152921 * sp[35] + 3.181980515339517 * sp[29] + 4.006938426723848 * sp[32] + 0.4714045207910404 * sp[28] + -2.003469213361917 * sp[29] + -7.660323462854288 * sp[26] + -10.13519719700728 * sp[27] + 0.4714045207910685 * sp[31] + 0.4714045207910328 * sp[32] + -5.185449728701313 * sp[27] + -4.006938426723792 * sp[30];
    A[13] = -16.88749537379666 * sp[33] + -7.361215932167781 * sp[34] + -7.361215932167801 * sp[28] + 3.897114317029952 * sp[31] + -5.196152422706692 * sp[34] + -6.278684177437289 * sp[35] + 4.979646071760496 * sp[29] + 3.897114317029932 * sp[32] + 5.196152422706645 * sp[28] + 11.90784930203617 * sp[29] + -21.8671414455571 * sp[26] + -15.15544456622756 * sp[27] + 5.196152422706618 * sp[31] + 5.196152422706667 * sp[32] + -1.732050807568854 * sp[27] + -3.897114317029886 * sp[30];
    A[14] = 10.41666666666666 * sp[33] + -2.916666666666671 * sp[34] + 10.08333333333334 * sp[28] + -1.416666666666686 * sp[31] + -5.83333333333338 * sp[34] + -4.375000000000007 * sp[35] + -2.875000000000028 * sp[29] + -1.416666666666758 * sp[32] + 0.8333333333333597 * sp[28] + -3.541666666666717 * sp[29] + 7.958333333333405 * sp[26] + 3.583333333333325 * sp[27] + 0.833333333333401 * sp[31] + 0.8333333333333373 * sp[32] + 1.833333333333368 * sp[27] + 2.916666666666643 * sp[30];
    A[15] = -2.016666666666673 * sp[33] + 0.2833333333333339 * sp[34] + 0.2166666666666656 * sp[28] + 0.2166666666666593 * sp[31] + 1.116666666666664 * sp[34] + -0.8000000000000103 * sp[35] + 1.666666666666685 * sp[29] + 0.2166666666666741 * sp[32] + -0.6166666666666692 * sp[28] + sp[29] + -3.466666666666688 * sp[26] + -0.7166666666666668 * sp[27] + -0.6166666666666804 * sp[31] + -0.6166666666666807 * sp[32] + 2.783333333333351 * sp[27] + 0.8166666666666623 * sp[30];
    A[16] = 2.533333333333342 * sp[33] + -1.73333333333334 * sp[34] + 0.7333333333333394 * sp[28] + 0.7333333333333495 * sp[31] + -1.73333333333334 * sp[34] + 2.766666666666676 * sp[35] + -2.166666666666679 * sp[29] + 0.733333333333347 * sp[32] + 0.7333333333333394 * sp[28] + -2.166666666666679 * sp[29] + 2.766666666666684 * sp[26] + -1.733333333333343 * sp[27] + 0.7333333333333495 * sp[31] + 0.733333333333347 * sp[32] + -1.733333333333343 * sp[27] + 2.533333333333348 * sp[30];
    A[17] = 0.8166666666666679 * sp[33] + 2.783333333333347 * sp[34] + -0.6166666666666732 * sp[28] + -0.6166666666666744 * sp[31] + -0.716666666666673 * sp[34] + -3.466666666666688 * sp[35] + sp[29] + -0.6166666666666745 * sp[32] + 0.2166666666666703 * sp[28] + 1.66666666666668 * sp[29] + -0.8000000000000094 * sp[26] + 1.116666666666668 * sp[27] + 0.2166666666666709 * sp[31] + 0.216666666666671 * sp[32] + 0.2833333333333339 * sp[27] + -2.016666666666679 * sp[30];
    A[18] = -0.06666666666666884 * sp[33] + -0.950000000000004 * sp[34] + 0.3166666666666714 * sp[28] + -0.949999999999996 * sp[31] + 0.4666666666666792 * sp[34] + 1.258333333333353 * sp[35] + -0.1083333333333333 * sp[29] + 0.6833333333333421 * sp[32] + 0.03333333333332944 * sp[28] + -0.7083333333333474 * sp[29] + 0.8583333333333331 * sp[26] + 0.1166666666666587 * sp[27] + 0.03333333333333344 * sp[31] + 0.03333333333333757 * sp[32] + 0.03333333333333249 * sp[27] + -0.1833333333333357 * sp[30];
    A[19] = 1.63333333333334 * sp[33] + 3.066666666666682 * sp[34] + 1.199999999999994 * sp[28] + 3.066666666666673 * sp[31] + -1.433333333333346 * sp[34] + -3.683333333333361 * sp[35] + -0.283333333333331 * sp[29] + -2.533333333333331 * sp[32] + 0.4333333333333392 * sp[28] + 1.58333333333335 * sp[29] + -0.216666666666666 * sp[26] + 0.9333333333333433 * sp[27] + 0.4333333333333441 * sp[31] + 0.4333333333333397 * sp[32] + 0.4333333333333446 * sp[27] + 1.200000000000019 * sp[30];
    A[20] = 1.266666666666667 * sp[33] + -2.116666666666677 * sp[34] + 2.483333333333341 * sp[28] + -2.116666666666676 * sp[31] + -0.8666666666666685 * sp[34] + 3.008333333333344 * sp[35] + -2.025000000000011 * sp[29] + 1.849999999999995 * sp[32] + 0.3666666666666698 * sp[28] + -1.958333333333343 * sp[29] + 1.275000000000012 * sp[26] + -1.050000000000009 * sp[27] + 0.366666666666673 * sp[31] + 0.3666666666666709 * sp[32] + 0.3666666666666765 * sp[27] + -1.016666666666666 * sp[30];
    A[21] = 0.1833333333333397 * sp[33] + -0.03333333333332378 * sp[34] + -0.03333333333333929 * sp[28] + -0.03333333333333585 * sp[31] + -0.1166666666666611 * sp[34] + -0.8583333333333498 * sp[35] + 0.7083333333333544 * sp[29] + -0.03333333333332811 * sp[32] + -0.6833333333333431 * sp[28] + 0.1083333333333386 * sp[29] + -1.258333333333347 * sp[26] + -0.4666666666666703 * sp[27] + 0.9500000000000037 * sp[31] + -0.3166666666666879 * sp[32] + 0.9500000000000044 * sp[27] + 0.0666666666666586 * sp[30];
    A[22] = -1.200000000000006 * sp[33] + -0.4333333333333302 * sp[34] + -0.4333333333333311 * sp[28] + -0.4333333333333266 * sp[31] + -0.9333333333333437 * sp[34] + 0.2166666666666575 * sp[35] + -1.58333333333336 * sp[29] + -0.4333333333333468 * sp[32] + 2.53333333333335 * sp[28] + 0.2833333333333323 * sp[29] + 3.68333333333336 * sp[26] + 1.433333333333335 * sp[27] + -3.066666666666685 * sp[31] + -1.199999999999991 * sp[32] + -3.066666666666686 * sp[27] + -1.633333333333326 * sp[30];
    A[23] = 1.016666666666668 * sp[33] + -0.366666666666687 * sp[34] + -0.3666666666666703 * sp[28] + -0.3666666666666815 * sp[31] + 1.050000000000004 * sp[34] + -1.275000000000009 * sp[35] + 1.958333333333347 * sp[29] + -0.3666666666666726 * sp[32] + -1.850000000000007 * sp[28] + 2.025000000000006 * sp[29] + -3.008333333333353 * sp[26] + 0.8666666666666748 * sp[27] + 2.116666666666682 * sp[31] + -2.483333333333345 * sp[32] + 2.11666666666668 * sp[27] + -1.266666666666679 * sp[30];
    A[24] = 3.77123616632826 * sp[33] + 6.128258770283455 * sp[34] + 3.299831645537228 * sp[28] + 3.299831645537251 * sp[31] + -3.771236166328295 * sp[34] + 1.178511301977608 * sp[35] + -1.64991582276857 * sp[29] + 3.299831645537293 * sp[32] + 0.9428090415820849 * sp[28] + -5.421151989096847 * sp[29] + -2.592724864350695 * sp[26] + -8.956685895029631 * sp[27] + 0.9428090415820771 * sp[31] + 12.25651754056689 * sp[32] + 3.771236166328277 * sp[27] + 11.78511301977581 * sp[30];
    A[25] = -8.948929172439174 * sp[33] + -1.443375672973963 * sp[34] + 3.752776749732562 * sp[28] + 3.752776749732618 * sp[31] + -3.175426480542823 * sp[34] + 2.020725942163682 * sp[35] + -1.443375672973955 * sp[29] + 3.75277674973267 * sp[32] + 1.443375672974014 * sp[28] + -7.216878364870303 * sp[29] + -3.752776749732616 * sp[26] + -12.41303078757702 * sp[27] + 1.443375672973947 * sp[31] + 10.10362971081836 * sp[32] + 4.907477288111845 * sp[27] + 14.14508159514585 * sp[30];
    A[26] = 11.1666666666667 * sp[33] + 1.833333333333356 * sp[34] + -5.166666666666718 * sp[28] + -5.166666666666707 * sp[31] + -8.166666666666712 * sp[34] + -16.66666666666674 * sp[35] + 3.333333333333383 * sp[29] + -5.166666666666746 * sp[32] + 3.166666666666703 * sp[28] + 10.66666666666669 * sp[29] + 2.666666666666668 * sp[26] + 10.16666666666669 * sp[27] + 3.166666666666733 * sp[31] + -7.833333333333411 * sp[32] + -4.833333333333391 * sp[27] + -17.16666666666675 * sp[30];
    A[27] = -11.78511301977583 * sp[33] + -3.771236166328274 * sp[34] + -12.25651754056684 * sp[28] + -0.9428090415820516 * sp[31] + 8.956685895029656 * sp[34] + 2.592724864350725 * sp[35] + 5.421151989096832 * sp[29] + -0.94280904158212 * sp[32] + -3.299831645537257 * sp[28] + 1.6499158227686 * sp[29] + -1.178511301977575 * sp[26] + 3.771236166328311 * sp[27] + -3.299831645537294 * sp[31] + -3.29983164553728 * sp[32] + -6.128258770283498 * sp[27] + -3.771236166328309 * sp[30];
    A[28] = 7.794228634059997 * sp[33] + 1.732050807568885 * sp[34] + 1.732050807568896 * sp[28] + -3.464101615137759 * sp[31] + -2.598076211353287 * sp[34] + -0.4330127018921264 * sp[35] + -5.629165124598781 * sp[29] + -3.464101615137685 * sp[32] + 2.598076211353324 * sp[28] + -2.165063509461184 * sp[29] + 13.42339375865884 * sp[26] + 8.660254037844336 * sp[27] + 2.598076211353373 * sp[31] + 2.598076211353395 * sp[32] + -0.8660254037845139 * sp[27] + -5.196152422706581 * sp[30];
    A[29] = -20.83333333333339 * sp[33] + -6.666666666666699 * sp[34] + -12.66666666666667 * sp[28] + 0.3333333333333777 * sp[31] + 15.83333333333343 * sp[34] + 4.583333333333418 * sp[35] + 11.58333333333335 * sp[29] + 0.3333333333335253 * sp[32] + -5.833333333333398 * sp[28] + 2.916666666666646 * sp[29] + -10.0833333333334 * sp[26] + -1.333333333333345 * sp[27] + -5.833333333333455 * sp[31] + -5.83333333333343 * sp[32] + 2.166666666666629 * sp[27] + 13.33333333333326 * sp[30];
    A[30] = -0.03333333333332916 * sp[33] + 0.4416666666666709 * sp[34] + -0.1916666666666685 * sp[28] + -0.1916666666666696 * sp[31] + -0.8916666666666657 * sp[34] + 1.275000000000009 * sp[35] + -0.7916666666666725 * sp[29] + -0.1916666666666731 * sp[32] + -0.1916666666666679 * sp[28] + -0.7916666666666765 * sp[29] + 1.275000000000009 * sp[26] + 0.4416666666666692 * sp[27] + -0.1916666666666637 * sp[31] + -0.1916666666666619 * sp[32] + -0.8916666666666733 * sp[27] + -0.03333333333332877 * sp[30];
    A[31] = 0.8166666666666679 * sp[33] + -0.716666666666673 * sp[34] + 0.2166666666666703 * sp[28] + 0.2166666666666709 * sp[31] + 2.783333333333347 * sp[34] + -3.466666666666688 * sp[35] + 1.66666666666668 * sp[29] + 0.216666666666671 * sp[32] + -0.6166666666666732 * sp[28] + sp[29] + -0.8000000000000094 * sp[26] + 0.2833333333333339 * sp[27] + -0.6166666666666744 * sp[31] + -0.6166666666666745 * sp[32] + 1.116666666666668 * sp[27] + -2.016666666666679 * sp[30];
    A[32] = 0.6333333333333359 * sp[33] + 1.691666666666676 * sp[34] + -0.6083333333333386 * sp[28] + -0.6083333333333368 * sp[31] + 1.691666666666676 * sp[34] + 6.191666666666701 * sp[35] + -1.875000000000016 * sp[29] + -0.6083333333333348 * sp[32] + -0.6083333333333386 * sp[28] + -1.875000000000016 * sp[29] + 0.8583333333333422 * sp[26] + 0.3583333333333358 * sp[27] + -0.6083333333333368 * sp[31] + -0.6083333333333348 * sp[32] + 0.3583333333333358 * sp[27] + 2.633333333333348 * sp[30];
    A[33] = -1.00833333333334 * sp[33] + -1.150000000000005 * sp[34] + -1.116666666666672 * sp[28] + -1.150000000000003 * sp[31] + -2.191666666666683 * sp[34] + -3.17083333333335 * sp[35] + -1.154166666666676 * sp[29] + -2.133333333333344 * sp[32] + 1.108333333333342 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000071 * sp[26] + 0.7333333333333414 * sp[27] + 1.108333333333338 * sp[31] + 1.108333333333332 * sp[32] + 1.10833333333334 * sp[27] + 1.091666666666669 * sp[30];
    A[34] = 1.266666666666673 * sp[33] + 2.133333333333344 * sp[34] + 0.8999999999999989 * sp[28] + 2.133333333333337 * sp[31] + 3.383333333333353 * sp[34] + 7.258333333333374 * sp[35] + 1.058333333333332 * sp[29] + 4.933333333333347 * sp[32] + -1.216666666666677 * sp[28] + -2.37500000000002 * sp[29] + -0.3083333333333363 * sp[26] + -1.466666666666678 * sp[27] + -1.216666666666675 * sp[31] + -1.21666666666667 * sp[32] + -1.216666666666673 * sp[27] + -2.600000000000015 * sp[30];
    A[35] = 0.4083333333333335 * sp[33] + -0.9833333333333406 * sp[34] + 0.7166666666666683 * sp[28] + -0.9833333333333405 * sp[31] + 1.391666666666671 * sp[34] + -4.295833333333358 * sp[35] + 2.887500000000015 * sp[29] + -2.800000000000019 * sp[32] + -0.3083333333333368 * sp[28] + 1.187500000000014 * sp[29] + -0.7625000000000084 * sp[26] + 0.7333333333333468 * sp[27] + -0.3083333333333366 * sp[31] + -0.308333333333336 * sp[32] + -0.3083333333333385 * sp[27] + 1.508333333333338 * sp[30];
    A[36] = -0.5083333333333319 * sp[33] + -0.691666666666664 * sp[34] + -0.6916666666666714 * sp[28] + -0.6916666666666695 * sp[31] + 0.2666666666666717 * sp[34] + 1.095833333333348 * sp[35] + -1.520833333333348 * sp[29] + -0.6916666666666692 * sp[32] + 0.4666666666666699 * sp[28] + 0.1124999999999979 * sp[29] + 1.295833333333342 * sp[26] + 0.9416666666666711 * sp[27] + 0.6499999999999988 * sp[31] + 2.283333333333354 * sp[32] + 0.6499999999999997 * sp[27] + 1.591666666666678 * sp[30];
    A[37] = 0.600000000000003 * sp[33] + 0.3833333333333363 * sp[34] + 0.3833333333333354 * sp[28] + 0.3833333333333364 * sp[31] + 0.1333333333333359 * sp[34] + -0.4416666666666573 * sp[35] + 0.9583333333333414 * sp[29] + 0.3833333333333414 * sp[32] + -0.9333333333333422 * sp[28] + -0.1416666666666695 * sp[29] + -1.67500000000001 * sp[26] + -0.8833333333333369 * sp[27] + 0.5333333333333374 * sp[31] + 0.09999999999999376 * sp[32] + 0.5333333333333425 * sp[27] + 0.06666666666665966 * sp[30];
    A[38] = -0.09166666666667111 * sp[33] + -0.1083333333333406 * sp[34] + -0.1083333333333348 * sp[28] + -0.108333333333337 * sp[31] + -0.4000000000000071 * sp[34] + 0.6374999999999883 * sp[35] + -1.145833333333341 * sp[29] + -0.1083333333333398 * sp[32] + 0.466666666666672 * sp[28] + -0.5124999999999975 * sp[29] + 0.8375000000000079 * sp[26] + -0.1416666666666673 * sp[27] + -1.183333333333337 * sp[31] + 2.116666666666679 * sp[32] + -1.183333333333339 * sp[27] + 1.008333333333342 * sp[30];
    A[39] = 4.006938426723792 * sp[33] + 5.185449728701373 * sp[34] + -0.4714045207910307 * sp[28] + -0.4714045207910284 * sp[31] + 10.13519719700724 * sp[34] + 7.660323462854305 * sp[35] + 2.003469213361893 * sp[29] + -0.4714045207910381 * sp[32] + -4.006938426723807 * sp[28] + -3.181980515339495 * sp[29] + 2.47487373415292 * sp[26] + 3.299831645537234 * sp[27] + -4.006938426723791 * sp[31] + -16.7348604880817 * sp[32] + 1.649915822768595 * sp[27] + -5.89255650988791 * sp[30];
    A[40] = -0.577350269189568 * sp[33] + -0.721687836486982 * sp[34] + -3.319764047840363 * sp[28] + -3.319764047840347 * sp[31] + 4.474464586219653 * sp[34] + 4.041451884327479 * sp[35] + -2.886751345948163 * sp[29] + -3.319764047840345 * sp[32] + -0.7216878364870516 * sp[28] + 6.92820323027554 * sp[26] + 7.649891066762572 * sp[27] + -0.7216878364870305 * sp[31] + -5.051814855409194 * sp[32] + 6.206515393788466 * sp[27] + -0.5773502691896146 * sp[30];
    A[41] = 4.833333333333342 * sp[33] + 2.416666666666693 * sp[34] + -4.08333333333337 * sp[28] + -4.083333333333353 * sp[31] + 14.91666666666673 * sp[34] + 22.91666666666679 * sp[35] + -12.08333333333345 * sp[29] + -4.083333333333332 * sp[32] + -4.08333333333337 * sp[28] + -5.750000000000027 * sp[29] + 3.25000000000004 * sp[26] + 1.583333333333347 * sp[27] + -4.083333333333366 * sp[31] + 11.41666666666674 * sp[32] + 4.916666666666712 * sp[27] + 19.83333333333344 * sp[30];
    A[42] = -5.892556509887917 * sp[33] + -4.006938426723782 * sp[34] + 0.2357022603955437 * sp[28] + 1.649915822768636 * sp[31] + -17.44196726926827 * sp[34] + -10.72445284799603 * sp[35] + -5.067598598503574 * sp[29] + 1.649915822768657 * sp[32] + 5.185449728701398 * sp[28] + 3.889087296526027 * sp[29] + -1.767766952966384 * sp[26] + -3.064129385141752 * sp[27] + 5.185449728701393 * sp[31] + 5.185449728701382 * sp[32] + -0.4714045207910114 * sp[27] + -1.649915822768603 * sp[30];
    A[43] = -3.897114317030001 * sp[33] + -3.031088913245556 * sp[34] + -3.031088913245558 * sp[28] + -0.4330127018922296 * sp[31] + -5.196152422706644 * sp[34] + -4.113620667976123 * sp[35] + -1.515544456622841 * sp[29] + -0.433012701892269 * sp[32] + 5.196152422706659 * sp[28] + 5.412658773652796 * sp[29] + -2.381569860407192 * sp[26] + -2.165063509461067 * sp[27] + 5.196152422706632 * sp[31] + 5.196152422706609 * sp[32] + -1.732050807568832 * sp[27] + 0.4330127018921683 * sp[30];
    A[44] = -10.4166666666667 * sp[33] + -7.08333333333335 * sp[34] + -4.083333333333326 * sp[28] + -0.5833333333332997 * sp[31] + -30.83333333333348 * sp[34] + -18.95833333333342 * sp[35] + -12.45833333333336 * sp[29] + -0.5833333333333515 * sp[32] + 9.166666666666753 * sp[28] + 6.875000000000025 * sp[29] + 3.375000000000038 * sp[26] + 1.083333333333313 * sp[27] + 9.166666666666742 * sp[31] + 9.166666666666719 * sp[32] + 0.1666666666666874 * sp[27] + -12.9166666666667 * sp[30];
    A[45] = -1.591666666666677 * sp[33] + -0.9416666666666769 * sp[34] + 0.6916666666666684 * sp[28] + 0.6916666666666678 * sp[31] + -0.6500000000000061 * sp[34] + -1.295833333333348 * sp[35] + 1.520833333333348 * sp[29] + 0.6916666666666722 * sp[32] + -2.28333333333335 * sp[28] + -0.112500000000004 * sp[29] + -1.095833333333332 * sp[26] + 0.6916666666666669 * sp[27] + -0.6500000000000127 * sp[31] + -0.4666666666666739 * sp[32] + -0.2666666666666587 * sp[27] + 0.5083333333333385 * sp[30];
    A[46] = -0.06666666666666884 * sp[33] + 0.4666666666666792 * sp[34] + 0.03333333333332944 * sp[28] + 0.03333333333333344 * sp[31] + -0.950000000000004 * sp[34] + 1.258333333333353 * sp[35] + -0.7083333333333474 * sp[29] + 0.03333333333333757 * sp[32] + 0.3166666666666714 * sp[28] + -0.1083333333333333 * sp[29] + 0.8583333333333331 * sp[26] + 0.03333333333333249 * sp[27] + -0.949999999999996 * sp[31] + 0.6833333333333421 * sp[32] + 0.1166666666666587 * sp[27] + -0.1833333333333357 * sp[30];
    A[47] = -1.00833333333334 * sp[33] + -2.191666666666683 * sp[34] + 1.108333333333342 * sp[28] + 1.108333333333338 * sp[31] + -1.150000000000005 * sp[34] + -3.17083333333335 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333332 * sp[32] + -1.116666666666672 * sp[28] + -1.154166666666676 * sp[29] + 0.3625000000000071 * sp[26] + 1.10833333333334 * sp[27] + -1.150000000000003 * sp[31] + -2.133333333333344 * sp[32] + 0.7333333333333414 * sp[27] + 1.091666666666669 * sp[30];
    A[48] = 2.633333333333349 * sp[33] + 2.275000000000012 * sp[34] + 3.241666666666683 * sp[28] + 2.275000000000012 * sp[31] + 2.275000000000012 * sp[34] + 2.775000000000011 * sp[35] + 1.008333333333344 * sp[29] + 1.508333333333341 * sp[32] + 3.241666666666683 * sp[28] + 1.008333333333344 * sp[29] + 10.04166666666667 * sp[26] + 5.50833333333334 * sp[27] + 2.275000000000012 * sp[31] + 1.508333333333341 * sp[32] + 5.50833333333334 * sp[27] + 3.683333333333336 * sp[30];
    A[49] = -2.016666666666679 * sp[33] + -3.133333333333353 * sp[34] + -1.400000000000005 * sp[28] + -3.133333333333342 * sp[31] + -2.30000000000001 * sp[34] + -4.216666666666684 * sp[35] + -0.6833333333333343 * sp[29] + -2.600000000000005 * sp[32] + -2.233333333333344 * sp[28] + -1.68333333333335 * sp[29] + -5.083333333333334 * sp[26] + -7.933333333333332 * sp[27] + -2.300000000000007 * sp[31] + -2.766666666666681 * sp[32] + -3.433333333333327 * sp[27] + -5.866666666666664 * sp[30];
    A[50] = -0.03333333333333585 * sp[33] + 0.8583333333333466 * sp[34] + 0.1583333333333301 * sp[28] + 0.8583333333333469 * sp[31] + -0.4750000000000023 * sp[34] + 1.691666666666684 * sp[35] + -1.075000000000007 * sp[29] + 1.091666666666682 * sp[32] + 0.1583333333333346 * sp[28] + 0.2583333333333384 * sp[29] + 1.625000000000001 * sp[26] + 2.425 * sp[27] + -0.4749999999999975 * sp[31] + 1.091666666666678 * sp[32] + -0.2416666666666655 * sp[27] + 2.183333333333339 * sp[30];
    A[51] = 1.508333333333334 * sp[33] + 1.816666666666668 * sp[34] + 1.816666666666674 * sp[28] + 1.816666666666671 * sp[31] + 0.7750000000000037 * sp[34] + 0.3208333333333283 * sp[35] + 2.270833333333345 * sp[29] + 1.816666666666672 * sp[32] + 4.308333333333327 * sp[28] + 7.504166666666666 * sp[29] + 0.3208333333333401 * sp[26] + 1.816666666666674 * sp[27] + 2.591666666666663 * sp[31] + 4.308333333333326 * sp[32] + 0.7750000000000079 * sp[27] + 1.508333333333337 * sp[30];
    A[52] = -2.600000000000008 * sp[33] + -1.383333333333338 * sp[34] + -1.383333333333334 * sp[28] + -1.383333333333335 * sp[31] + -1.133333333333349 * sp[34] + -0.2250000000000075 * sp[35] + -2.291666666666682 * sp[29] + -1.383333333333341 * sp[32] + -7.533333333333333 * sp[28] + -5.258333333333333 * sp[29] + 0.9416666666666662 * sp[26] + -1.383333333333333 * sp[27] + -3.933333333333342 * sp[31] + -2.86666666666667 * sp[32] + 0.03333333333332594 * sp[27] + -1.016666666666672 * sp[30];
    A[53] = 1.091666666666675 * sp[33] + -0.01666666666666289 * sp[34] + -0.01666666666666672 * sp[28] + -0.01666666666666833 * sp[31] + 0.3583333333333455 * sp[34] + -0.3874999999999975 * sp[35] + 0.7291666666666781 * sp[29] + -0.01666666666666848 * sp[32] + 3.225000000000008 * sp[28] + 0.9625000000000006 * sp[29] + -1.054166666666669 * sp[26] + -0.01666666666666893 * sp[27] + 1.34166666666668 * sp[31] + 0.5583333333333393 * sp[32] + -0.3083333333333279 * sp[27] + 0.09166666666666919 * sp[30];
    A[54] = -7.542472332656567 * sp[33] + -8.720983634634127 * sp[34] + 4.006938426723765 * sp[28] + 4.006938426723776 * sp[31] + -7.778174593052068 * sp[34] + -8.249579113843062 * sp[35] + 4.478342947514809 * sp[29] + 4.006938426723806 * sp[32] + -8.720983634634145 * sp[28] + -12.96362432175341 * sp[29] + -0.2357022603955121 * sp[26] + 4.006938426723768 * sp[27] + -7.778174593052059 * sp[31] + -11.07800623858926 * sp[32] + 0.2357022603955192 * sp[27] + 2.357022603955168 * sp[30];
    A[55] = -5.917840259193747 * sp[33] + 0.7216878364869923 * sp[34] + 11.98001808568476 * sp[28] + 11.98001808568476 * sp[31] + -0.8660254037844877 * sp[34] + -2.237232293109841 * sp[35] + 13.35122497501013 * sp[29] + 11.98001808568479 * sp[32] + -11.83568051838745 * sp[28] + 18.25870226312187 * sp[29] + 2.670244995002064 * sp[26] + 11.98001808568476 * sp[27] + -0.8660254037845783 * sp[31] + 10.96965511460281 * sp[32] + 4.04145188432741 * sp[27] + 8.804591605141807 * sp[30];
    A[56] = -3.583333333333354 * sp[33] + -4.916666666666697 * sp[34] + 6.583333333333396 * sp[28] + 6.583333333333364 * sp[31] + -7.000000000000024 * sp[34] + -7.708333333333363 * sp[35] + 7.291666666666713 * sp[29] + 6.583333333333314 * sp[32] + -2.666666666666649 * sp[28] + 4.458333333333289 * sp[29] + 5.458333333333387 * sp[26] + 6.583333333333383 * sp[27] + -6.999999999999984 * sp[31] + 2.166666666666598 * sp[32] + 6.16666666666671 * sp[27] + 6.91666666666667 * sp[30];
    A[57] = 5.892556509887943 * sp[33] + 7.542472332656526 * sp[34] + -10.84230397819378 * sp[28] + -5.185449728701402 * sp[31] + 9.19238815542516 * sp[34] + 8.367430244040808 * sp[35] + -4.360491817317088 * sp[29] + -5.185449728701423 * sp[32] + 5.421151989096883 * sp[28] + 5.067598598503627 * sp[29] + -18.9740319618391 * sp[26] + -5.185449728701383 * sp[27] + 9.192388155425126 * sp[31] + 5.892556509887905 * sp[32] + -6.835365551470035 * sp[27] + -4.006938426723817 * sp[30];
    A[58] = 16.88749537379664 * sp[33] + 9.526279441628882 * sp[34] + 9.526279441628906 * sp[28] + -1.732050807568834 * sp[31] + 11.69134295108997 * sp[34] + 10.60881119635945 * sp[35] + -0.6495190528382926 * sp[29] + -1.732050807568841 * sp[32] + 22.08364779650329 * sp[28] + 2.814582562299456 * sp[29] + 36.58957330989259 * sp[26] + -1.732050807568859 * sp[27] + 11.69134295108999 * sp[31] + 3.897114317030005 * sp[32] + 19.4855715851499 * sp[27] + 0.4330127018922278 * sp[30];
    A[59] = 10.41666666666675 * sp[33] + 13.33333333333336 * sp[34] + 0.3333333333333379 * sp[28] + 1.833333333333298 * sp[31] + 16.25000000000008 * sp[34] + 14.79166666666666 * sp[35] + 3.291666666666697 * sp[29] + 1.833333333333316 * sp[32] + 9.58333333333335 * sp[28] + 8.958333333333393 * sp[29] + 7.458333333333292 * sp[26] + 1.833333333333306 * sp[27] + 16.25 * sp[31] + 10.41666666666667 * sp[32] + 9.416666666666636 * sp[27] + 2.916666666666619 * sp[30];
    A[60] = -0.06666666666666266 * sp[33] + 0.8833333333333411 * sp[34] + -0.3833333333333338 * sp[28] + -0.3833333333333384 * sp[31] + -0.5333333333333306 * sp[34] + 1.675000000000012 * sp[35] + -0.9583333333333403 * sp[29] + -0.3833333333333411 * sp[32] + -0.09999999999999098 * sp[28] + 0.1416666666666681 * sp[29] + 0.4416666666666673 * sp[26] + -0.383333333333338 * sp[27] + -0.5333333333333307 * sp[31] + 0.9333333333333305 * sp[32] + -0.133333333333332 * sp[27] + -0.6000000000000051 * sp[30];
    A[61] = 1.63333333333334 * sp[33] + -1.433333333333346 * sp[34] + 0.4333333333333392 * sp[28] + 0.4333333333333441 * sp[31] + 3.066666666666682 * sp[34] + -3.683333333333361 * sp[35] + 1.58333333333335 * sp[29] + 0.4333333333333397 * sp[32] + 1.199999999999994 * sp[28] + -0.283333333333331 * sp[29] + -0.216666666666666 * sp[26] + 0.4333333333333446 * sp[27] + 3.066666666666673 * sp[31] + -2.533333333333331 * sp[32] + 0.9333333333333433 * sp[27] + 1.200000000000019 * sp[30];
    A[62] = 1.266666666666673 * sp[33] + 3.383333333333353 * sp[34] + -1.216666666666677 * sp[28] + -1.216666666666675 * sp[31] + 2.133333333333344 * sp[34] + 7.258333333333374 * sp[35] + -2.37500000000002 * sp[29] + -1.21666666666667 * sp[32] + 0.8999999999999989 * sp[28] + 1.058333333333332 * sp[29] + -0.3083333333333363 * sp[26] + -1.216666666666673 * sp[27] + 2.133333333333337 * sp[31] + 4.933333333333347 * sp[32] + -1.466666666666678 * sp[27] + -2.600000000000015 * sp[30];
    A[63] = -2.016666666666679 * sp[33] + -2.30000000000001 * sp[34] + -2.233333333333344 * sp[28] + -2.300000000000007 * sp[31] + -3.133333333333353 * sp[34] + -4.216666666666684 * sp[35] + -1.68333333333335 * sp[29] + -2.766666666666681 * sp[32] + -1.400000000000005 * sp[28] + -0.6833333333333343 * sp[29] + -5.083333333333334 * sp[26] + -3.433333333333327 * sp[27] + -3.133333333333342 * sp[31] + -2.600000000000005 * sp[32] + -7.933333333333332 * sp[27] + -5.866666666666664 * sp[30];
    A[64] = 2.533333333333347 * sp[33] + 4.26666666666669 * sp[34] + 1.800000000000001 * sp[28] + 4.266666666666678 * sp[31] + 4.26666666666669 * sp[34] + 8.766666666666712 * sp[35] + 1.366666666666667 * sp[29] + 5.866666666666687 * sp[32] + 1.800000000000001 * sp[28] + 1.366666666666667 * sp[29] + 3.833333333333325 * sp[26] + 5.866666666666656 * sp[27] + 4.266666666666678 * sp[31] + 5.866666666666687 * sp[32] + 5.866666666666656 * sp[27] + 11.73333333333334 * sp[30];
    A[65] = 0.8166666666666693 * sp[33] + -1.966666666666682 * sp[34] + 1.43333333333334 * sp[28] + -1.966666666666684 * sp[31] + 1.533333333333339 * sp[34] + -4.716666666666699 * sp[35] + 3.150000000000015 * sp[29] + -3.100000000000029 * sp[32] + 0.5999999999999953 * sp[28] + -0.5166666666666666 * sp[29] + 0.4166666666666621 * sp[26] + -2.433333333333331 * sp[27] + 1.533333333333333 * sp[31] + -3.266666666666674 * sp[32] + 2.066666666666676 * sp[27] + -5.866666666666673 * sp[30];
    A[66] = -1.016666666666664 * sp[33] + -1.383333333333329 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333338 * sp[31] + 0.03333333333333732 * sp[34] + 0.9416666666666779 * sp[35] + -2.291666666666682 * sp[29] + -1.383333333333337 * sp[32] + -2.866666666666659 * sp[28] + -5.258333333333324 * sp[29] + -0.2250000000000023 * sp[26] + -1.383333333333336 * sp[27] + -3.933333333333318 * sp[31] + -7.533333333333328 * sp[32] + -1.133333333333338 * sp[27] + -2.600000000000006 * sp[30];
    A[67] = 1.200000000000002 * sp[33] + 0.7666666666666726 * sp[34] + 0.7666666666666668 * sp[28] + 0.766666666666671 * sp[31] + 0.2666666666666755 * sp[34] + -0.3833333333333203 * sp[35] + 1.416666666666675 * sp[29] + 0.7666666666666757 * sp[32] + 3.73333333333333 * sp[28] + 3.016666666666667 * sp[29] + -0.3833333333333352 * sp[26] + 0.766666666666669 * sp[27] + 5.866666666666658 * sp[31] + 3.733333333333335 * sp[32] + 0.2666666666666623 * sp[27] + 1.200000000000003 * sp[30];
    A[68] = -0.1833333333333382 * sp[33] + -0.2166666666666833 * sp[34] + -0.2166666666666679 * sp[28] + -0.2166666666666752 * sp[31] + -0.3000000000000127 * sp[34] + 0.5249999999999839 * sp[35] + -1.041666666666677 * sp[29] + -0.2166666666666747 * sp[32] + -0.8666666666666717 * sp[28] + -1.008333333333348 * sp[29] + 0.3583333333333346 * sp[26] + -0.2166666666666751 * sp[27] + -1.933333333333338 * sp[31] + -1.533333333333357 * sp[32] + -0.4666666666666703 * sp[27] + -0.6000000000000137 * sp[30];
    A[69] = 8.013876853447588 * sp[33] + 10.37089945740276 * sp[34] + -0.9428090415820536 * sp[28] + -0.9428090415820456 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977585 * sp[35] + 0.4714045207910482 * sp[29] + -0.9428090415820688 * sp[32] + 5.65685424949239 * sp[28] + 11.78511301977581 * sp[29] + 0.4714045207910345 * sp[26] + -0.9428090415820389 * sp[27] + 13.19932658214892 * sp[31] + 24.51303508113374 * sp[32] + 1.88561808316416 * sp[27];
    A[70] = -1.154700538379172 * sp[33] + -1.443375672973972 * sp[34] + -6.639528095680715 * sp[28] + -6.639528095680678 * sp[31] + 4.618802153517112 * sp[34] + 5.917840259193776 * sp[35] + -7.938566201357379 * sp[29] + -6.63952809568069 * sp[32] + -5.196152422706532 * sp[28] + -14.86676943163276 * sp[29] + -1.010362971081855 * sp[26] + -6.639528095680663 * sp[27] + 4.618802153517141 * sp[31] + -16.16580753730939 * sp[32] + -2.309401076758483 * sp[27] + -10.3923048454132 * sp[30];
    A[71] = 9.666666666666703 * sp[33] + 4.833333333333361 * sp[34] + -8.166666666666748 * sp[28] + -8.166666666666721 * sp[31] + 17.33333333333341 * sp[34] + 24.58333333333346 * sp[35] + -15.4166666666668 * sp[29] + -8.166666666666675 * sp[32] + 6.999999999999967 * sp[28] + -11.41666666666666 * sp[29] + -3.416666666666693 * sp[26] + -8.166666666666703 * sp[27] + 17.33333333333335 * sp[31] + -2.666666666666629 * sp[32] + -10.66666666666676 * sp[27] + -18.0000000000001 * sp[30];
    A[72] = -11.78511301977585 * sp[33] + -8.013876853447567 * sp[34] + 0.4714045207910602 * sp[28] + 3.299831645537267 * sp[31] + -20.7417989148055 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141675 * sp[29] + 3.299831645537287 * sp[32] + -8.485281374238548 * sp[28] + -3.064129385141709 * sp[29] + 2.592724864350728 * sp[26] + 3.299831645537247 * sp[27] + -20.74179891480543 * sp[31] + -9.428090415820687 * sp[32] + 1.885618083164142 * sp[27] + 5.656854249492397 * sp[30];
    A[73] = -7.794228634059981 * sp[33] + -6.062177826491105 * sp[34] + -6.062177826491127 * sp[28] + -0.8660254037844766 * sp[31] + -10.39230484541329 * sp[34] + -8.227241335952211 * sp[35] + -3.031088913245625 * sp[29] + -0.8660254037844877 * sp[32] + -5.19615242270666 * sp[28] + -1.299038105676664 * sp[29] + -16.88749537379658 * sp[26] + -0.8660254037844569 * sp[27] + -10.39230484541324 * sp[31] + -3.464101615137731 * sp[32] + -17.32050807568881 * sp[27] + 3.464101615137753 * sp[30];
    A[74] = -20.83333333333343 * sp[33] + -14.16666666666671 * sp[34] + -8.166666666666673 * sp[28] + -1.166666666666608 * sp[31] + -36.66666666666684 * sp[34] + -25.41666666666674 * sp[35] + -12.4166666666667 * sp[29] + -1.166666666666637 * sp[32] + -14.99999999999995 * sp[28] + -5.416666666666665 * sp[29] + -12.41666666666661 * sp[26] + -1.166666666666613 * sp[27] + -36.66666666666672 * sp[31] + -16.66666666666675 * sp[32] + -24.66666666666664 * sp[27] + 10.00000000000008 * sp[30];
    A[75] = -1.008333333333333 * sp[33] + 0.1416666666666675 * sp[34] + 0.1083333333333307 * sp[28] + 0.1083333333333287 * sp[31] + 1.183333333333333 * sp[34] + -0.837500000000007 * sp[35] + 1.145833333333343 * sp[29] + 0.1083333333333392 * sp[32] + -2.116666666666671 * sp[28] + 0.5125000000000047 * sp[29] + -0.6375000000000097 * sp[26] + 0.1083333333333248 * sp[27] + 1.183333333333333 * sp[31] + -0.4666666666666676 * sp[32] + 0.40000000000001 * sp[27] + 0.09166666666667571 * sp[30];
    A[76] = 1.266666666666667 * sp[33] + -0.8666666666666685 * sp[34] + 0.3666666666666698 * sp[28] + 0.366666666666673 * sp[31] + -2.116666666666677 * sp[34] + 3.008333333333344 * sp[35] + -1.958333333333343 * sp[29] + 0.3666666666666709 * sp[32] + 2.483333333333341 * sp[28] + -2.025000000000011 * sp[29] + 1.275000000000012 * sp[26] + 0.3666666666666765 * sp[27] + -2.116666666666676 * sp[31] + 1.849999999999995 * sp[32] + -1.050000000000009 * sp[27] + -1.016666666666666 * sp[30];
    A[77] = 0.4083333333333335 * sp[33] + 1.391666666666671 * sp[34] + -0.3083333333333368 * sp[28] + -0.3083333333333366 * sp[31] + -0.9833333333333406 * sp[34] + -4.295833333333358 * sp[35] + 1.187500000000014 * sp[29] + -0.308333333333336 * sp[32] + 0.7166666666666683 * sp[28] + 2.887500000000015 * sp[29] + -0.7625000000000084 * sp[26] + -0.3083333333333385 * sp[27] + -0.9833333333333405 * sp[31] + -2.800000000000019 * sp[32] + 0.7333333333333468 * sp[27] + 1.508333333333338 * sp[30];
    A[78] = -0.03333333333333585 * sp[33] + -0.4750000000000023 * sp[34] + 0.1583333333333346 * sp[28] + -0.4749999999999975 * sp[31] + 0.8583333333333466 * sp[34] + 1.691666666666684 * sp[35] + 0.2583333333333384 * sp[29] + 1.091666666666678 * sp[32] + 0.1583333333333301 * sp[28] + -1.075000000000007 * sp[29] + 1.625000000000001 * sp[26] + -0.2416666666666655 * sp[27] + 0.8583333333333469 * sp[31] + 1.091666666666682 * sp[32] + 2.425 * sp[27] + 2.183333333333339 * sp[30];
    A[79] = 0.8166666666666693 * sp[33] + 1.533333333333339 * sp[34] + 0.5999999999999953 * sp[28] + 1.533333333333333 * sp[31] + -1.966666666666682 * sp[34] + -4.716666666666699 * sp[35] + -0.5166666666666666 * sp[29] + -3.266666666666674 * sp[32] + 1.43333333333334 * sp[28] + 3.150000000000015 * sp[29] + 0.4166666666666621 * sp[26] + 2.066666666666676 * sp[27] + -1.966666666666684 * sp[31] + -3.100000000000029 * sp[32] + -2.433333333333331 * sp[27] + -5.866666666666673 * sp[30];
    A[80] = 0.633333333333332 * sp[33] + -1.058333333333336 * sp[34] + 1.241666666666668 * sp[28] + -1.058333333333336 * sp[31] + -1.058333333333336 * sp[34] + 3.441666666666681 * sp[35] + -2.325000000000011 * sp[29] + 2.175000000000004 * sp[32] + 1.241666666666668 * sp[28] + -2.325000000000011 * sp[29] + 2.708333333333341 * sp[26] + -1.825000000000012 * sp[27] + -1.058333333333336 * sp[31] + 2.175000000000004 * sp[32] + -1.825000000000012 * sp[27] + 3.683333333333326 * sp[30];
    A[81] = 0.09166666666666894 * sp[33] + -0.01666666666666186 * sp[34] + -0.01666666666667128 * sp[28] + -0.01666666666666905 * sp[31] + -0.3083333333333318 * sp[34] + -1.054166666666679 * sp[35] + 0.7291666666666833 * sp[29] + -0.01666666666666317 * sp[32] + 0.5583333333333336 * sp[28] + 0.9625000000000068 * sp[29] + -0.3875000000000099 * sp[26] + -0.01666666666667116 * sp[27] + 1.341666666666665 * sp[31] + 3.224999999999997 * sp[32] + 0.3583333333333503 * sp[27] + 1.091666666666679 * sp[30];
    A[82] = -0.5999999999999996 * sp[33] + -0.2166666666666642 * sp[34] + -0.2166666666666625 * sp[28] + -0.2166666666666614 * sp[31] + -0.4666666666666719 * sp[34] + 0.3583333333333236 * sp[35] + -1.041666666666681 * sp[29] + -0.2166666666666761 * sp[32] + -1.533333333333327 * sp[28] + -1.008333333333328 * sp[29] + 0.5250000000000128 * sp[26] + -0.2166666666666568 * sp[27] + -1.933333333333334 * sp[31] + -0.8666666666666752 * sp[32] + -0.3000000000000148 * sp[27] + -0.1833333333333493 * sp[30];
    A[83] = 0.5083333333333313 * sp[33] + -0.1833333333333421 * sp[34] + -0.1833333333333359 * sp[28] + -0.18333333333334 * sp[31] + 0.775000000000003 * sp[34] + -1.012499999999999 * sp[35] + 1.604166666666675 * sp[29] + -0.1833333333333331 * sp[32] + 0.9749999999999953 * sp[28] + 0.1708333333333183 * sp[29] + -1.012500000000011 * sp[26] + -0.1833333333333441 * sp[27] + 0.5916666666666676 * sp[31] + 0.9749999999999994 * sp[32] + 0.7750000000000078 * sp[27] + 0.5083333333333359 * sp[30];
    A[84] = 1.885618083164129 * sp[33] + 3.064129385141721 * sp[34] + 1.649915822768605 * sp[28] + 1.649915822768616 * sp[31] + -5.42115198909691 * sp[34] + -1.178511301977587 * sp[35] + -2.592724864350657 * sp[29] + 1.649915822768645 * sp[32] + 3.064129385141716 * sp[28] + 3.535533905932771 * sp[29] + 2.121320343559636 * sp[26] + 1.649915822768613 * sp[27] + -5.421151989096911 * sp[31] + -13.43502884254444 * sp[32] + -2.121320343559625 * sp[27] + -2.357022603955114 * sp[30];
    A[85] = -4.47446458621957 * sp[33] + -0.7216878364869789 * sp[34] + 1.876388374866266 * sp[28] + 1.876388374866292 * sp[31] + -3.752776749732504 * sp[34] + -0.07216878364873935 * sp[35] + -1.804219591217512 * sp[29] + 1.876388374866327 * sp[32] + -8.948929172439181 * sp[28] + 0.2165063509461903 * sp[29] + 1.948557158514961 * sp[26] + 1.876388374866291 * sp[27] + -3.752776749732487 * sp[31] + 5.196152422706637 * sp[32] + -1.732050807568799 * sp[27] + 1.587713240271555 * sp[30];
    A[86] = 5.583333333333337 * sp[33] + 0.9166666666666845 * sp[34] + -2.583333333333355 * sp[28] + -2.583333333333346 * sp[31] + -10.33333333333339 * sp[34] + -18.95833333333341 * sp[35] + 6.04166666666674 * sp[29] + -2.583333333333369 * sp[32] + 10.6666666666667 * sp[28] + 4.875000000000029 * sp[29] + -4.125000000000037 * sp[26] + -2.58333333333335 * sp[27] + -10.33333333333339 * sp[31] + 0.5 * sp[32] + 4.500000000000076 * sp[27] + 11.08333333333335 * sp[30];
    A[87] = -5.892556509887902 * sp[33] + -1.885618083164137 * sp[34] + -6.128258770283398 * sp[28] + -0.4714045207910202 * sp[31] + 11.54941075938034 * sp[34] + 4.831896338108131 * sp[35] + 6.246109900481153 * sp[29] + -0.4714045207910718 * sp[32] + -11.07800623858928 * sp[28] + -3.18198051533948 * sp[29] + -13.08147545195113 * sp[26] + -0.4714045207910007 * sp[27] + 11.54941075938035 * sp[31] + 3.535533905932826 * sp[32] + 4.94974746830582 * sp[27] + -1.649915822768632 * sp[30];
    A[88] = 3.897114317029978 * sp[33] + 0.8660254037844326 * sp[34] + 0.8660254037844487 * sp[28] + -1.73205080756887 * sp[31] + -1.299038105676645 * sp[34] + -0.2165063509460512 * sp[35] + -2.814582562299341 * sp[29] + -1.732050807568813 * sp[32] + 9.093266739736643 * sp[28] + 0.6495190528383092 * sp[29] + 8.443747686898309 * sp[26] + -1.732050807568873 * sp[27] + -1.299038105676638 * sp[31] + -0.4330127018921792 * sp[32] + -2.165063509461007 * sp[27] + -3.897114317029972 * sp[30];
    A[89] = -10.41666666666667 * sp[33] + -3.333333333333347 * sp[34] + -6.333333333333318 * sp[28] + 0.1666666666666874 * sp[31] + 20.41666666666679 * sp[34] + 8.541666666666762 * sp[35] + 12.04166666666669 * sp[29] + 0.1666666666667926 * sp[32] + -19.58333333333339 * sp[28] + -5.625000000000021 * sp[29] + -12.12500000000002 * sp[26] + 0.1666666666667045 * sp[27] + 20.41666666666678 * sp[31] + 6.250000000000149 * sp[32] + 15.25000000000001 * sp[27] + -12.91666666666651 * sp[30];
    A[90] = -1.091666666666674 * sp[33] + -0.7333333333333441 * sp[34] + 2.133333333333345 * sp[28] + 1.149999999999999 * sp[31] + -1.108333333333342 * sp[34] + -0.3624999999999955 * sp[35] + 1.154166666666652 * sp[29] + 1.116666666666661 * sp[32] + -1.108333333333335 * sp[28] + -1.479166666666684 * sp[29] + 3.170833333333344 * sp[26] + 1.149999999999999 * sp[27] + -1.108333333333336 * sp[31] + -1.108333333333341 * sp[32] + 2.191666666666666 * sp[27] + 1.008333333333332 * sp[30];
    A[91] = 0.1833333333333397 * sp[33] + -0.1166666666666611 * sp[34] + -0.6833333333333431 * sp[28] + 0.9500000000000037 * sp[31] + -0.03333333333332378 * sp[34] + -0.8583333333333498 * sp[35] + 0.1083333333333386 * sp[29] + -0.3166666666666879 * sp[32] + -0.03333333333333929 * sp[28] + 0.7083333333333544 * sp[29] + -1.258333333333347 * sp[26] + 0.9500000000000044 * sp[27] + -0.03333333333333585 * sp[31] + -0.03333333333332811 * sp[32] + -0.4666666666666703 * sp[27] + 0.0666666666666586 * sp[30];
    A[92] = -0.5083333333333319 * sp[33] + 0.2666666666666717 * sp[34] + 0.4666666666666699 * sp[28] + 0.6499999999999988 * sp[31] + -0.691666666666664 * sp[34] + 1.095833333333348 * sp[35] + 0.1124999999999979 * sp[29] + 2.283333333333354 * sp[32] + -0.6916666666666714 * sp[28] + -1.520833333333348 * sp[29] + 1.295833333333342 * sp[26] + 0.6499999999999997 * sp[27] + -0.6916666666666695 * sp[31] + -0.6916666666666692 * sp[32] + 0.9416666666666711 * sp[27] + 1.591666666666678 * sp[30];
    A[93] = 1.508333333333334 * sp[33] + 0.7750000000000037 * sp[34] + 4.308333333333327 * sp[28] + 2.591666666666663 * sp[31] + 1.816666666666668 * sp[34] + 0.3208333333333283 * sp[35] + 7.504166666666666 * sp[29] + 4.308333333333326 * sp[32] + 1.816666666666674 * sp[28] + 2.270833333333345 * sp[29] + 0.3208333333333401 * sp[26] + 0.7750000000000079 * sp[27] + 1.816666666666671 * sp[31] + 1.816666666666672 * sp[32] + 1.816666666666674 * sp[27] + 1.508333333333337 * sp[30];
    A[94] = -1.016666666666664 * sp[33] + 0.03333333333333732 * sp[34] + -2.866666666666659 * sp[28] + -3.933333333333318 * sp[31] + -1.383333333333329 * sp[34] + 0.9416666666666779 * sp[35] + -5.258333333333324 * sp[29] + -7.533333333333328 * sp[32] + -1.383333333333342 * sp[28] + -2.291666666666682 * sp[29] + -0.2250000000000023 * sp[26] + -1.133333333333338 * sp[27] + -1.383333333333338 * sp[31] + -1.383333333333337 * sp[32] + -1.383333333333336 * sp[27] + -2.600000000000006 * sp[30];
    A[95] = 0.09166666666666894 * sp[33] + -0.3083333333333318 * sp[34] + 0.5583333333333336 * sp[28] + 1.341666666666665 * sp[31] + -0.01666666666666186 * sp[34] + -1.054166666666679 * sp[35] + 0.9625000000000068 * sp[29] + 3.224999999999997 * sp[32] + -0.01666666666667128 * sp[28] + 0.7291666666666833 * sp[29] + -0.3875000000000099 * sp[26] + 0.3583333333333503 * sp[27] + -0.01666666666666905 * sp[31] + -0.01666666666666317 * sp[32] + -0.01666666666667116 * sp[27] + 1.091666666666679 * sp[30];
    A[96] = 3.683333333333331 * sp[33] + 5.508333333333319 * sp[34] + 1.508333333333336 * sp[28] + 2.274999999999999 * sp[31] + 5.508333333333319 * sp[34] + 10.04166666666667 * sp[35] + 1.008333333333323 * sp[29] + 3.241666666666669 * sp[32] + 1.508333333333336 * sp[28] + 1.008333333333323 * sp[29] + 2.775000000000007 * sp[26] + 2.275 * sp[27] + 2.274999999999999 * sp[31] + 3.241666666666669 * sp[32] + 2.275 * sp[27] + 2.633333333333338 * sp[30];
    A[97] = -5.866666666666672 * sp[33] + -3.433333333333325 * sp[34] + -2.766666666666677 * sp[28] + -2.299999999999996 * sp[31] + -7.933333333333318 * sp[34] + -5.083333333333318 * sp[35] + -1.683333333333312 * sp[29] + -2.233333333333319 * sp[32] + -2.600000000000009 * sp[28] + -0.6833333333333306 * sp[29] + -4.216666666666677 * sp[26] + -2.299999999999997 * sp[27] + -3.133333333333333 * sp[31] + -1.399999999999995 * sp[32] + -3.13333333333333 * sp[27] + -2.016666666666661 * sp[30];
    A[98] = 2.183333333333341 * sp[33] + -0.2416666666666683 * sp[34] + 1.091666666666676 * sp[28] + -0.4750000000000057 * sp[31] + 2.424999999999999 * sp[34] + 1.625000000000021 * sp[35] + 0.2583333333333242 * sp[29] + 0.1583333333333411 * sp[32] + 1.091666666666673 * sp[28] + -1.075 * sp[29] + 1.691666666666678 * sp[26] + -0.4750000000000058 * sp[27] + 0.8583333333333339 * sp[31] + 0.1583333333333449 * sp[32] + 0.8583333333333337 * sp[27] + -0.0333333333333318 * sp[30];
    A[99] = -4.006938426723776 * sp[33] + -6.835365551469938 * sp[34] + 5.892556509887898 * sp[28] + 9.192388155425125 * sp[31] + -5.18544972870135 * sp[34] + -18.97403196183912 * sp[35] + 5.067598598503546 * sp[29] + 5.421151989096768 * sp[32] + -5.185449728701388 * sp[28] + -4.360491817317055 * sp[29] + 8.367430244040804 * sp[26] + 9.192388155425128 * sp[27] + -5.185449728701376 * sp[31] + -10.8423039781938 * sp[32] + 7.542472332656487 * sp[27] + 5.892556509887863 * sp[30];
    A[100] = 2.742413778650681 * sp[33] + 17.89785834487833 * sp[34] + 10.9696551146029 * sp[28] + 19.9185842870421 * sp[31] + 0.7216878364868515 * sp[34] + 24.75389279150508 * sp[35] + 9.165435523385241 * sp[29] + 19.34123401785236 * sp[32] + 0.721687836487015 * sp[28] + 2.525907427704556 * sp[29] + 18.11436469582451 * sp[26] + 19.91858428704211 * sp[27] + 0.7216878364869777 * sp[31] + 5.051814855409161 * sp[32] + 16.31014510460691 * sp[27] + 17.46484564298616 * sp[30];
    A[101] = -1.0833333333333 * sp[33] + 12.16666666666668 * sp[34] + -1.833333333333353 * sp[28] + 1.999999999999988 * sp[31] + -2.416666666666613 * sp[34] + 27.95833333333339 * sp[35] + -2.041666666666655 * sp[29] + 14.3333333333335 * sp[32] + -2.4166666666667 * sp[28] + -2.20833333333334 * sp[29] + 1.791666666666695 * sp[26] + 2.0 * sp[27] + -2.416666666666679 * sp[31] + 8.083333333333396 * sp[32] + 1.58333333333336 * sp[27] + 9.416666666666757 * sp[30];
    A[102] = 2.357022603955131 * sp[33] + 0.2357022603954846 * sp[34] + -11.07800623858928 * sp[28] + -7.778174593052078 * sp[31] + 4.006938426723726 * sp[34] + -0.2357022603955086 * sp[35] + -12.9636243217534 * sp[29] + -8.720983634634081 * sp[32] + 4.006938426723814 * sp[28] + 4.478342947514788 * sp[29] + -8.249579113843065 * sp[26] + -7.778174593052094 * sp[27] + 4.006938426723792 * sp[31] + 4.006938426723767 * sp[32] + -8.720983634634095 * sp[27] + -7.542472332656549 * sp[30];
    A[103] = 10.39230484541329 * sp[33] + 7.361215932167788 * sp[34] + 7.36121593216771 * sp[28] + -6.49519052838323 * sp[31] + 11.69134295108995 * sp[34] + 6.06217782649105 * sp[35] + 12.99038105676659 * sp[29] + -8.227241335952161 * sp[32] + 11.69134295108995 * sp[28] + 12.99038105676667 * sp[29] + -7.794228634059923 * sp[26] + -6.495190528383204 * sp[27] + 11.69134295108995 * sp[31] + 11.69134295108997 * sp[32] + -3.897114317029954 * sp[27] + -6.062177826491025 * sp[30];
    A[104] = 4.166666666666618 * sp[33] + 0.416666666666611 * sp[34] + 8.416666666666657 * sp[28] + 2.749999999999959 * sp[31] + 7.083333333333249 * sp[34] + -0.4166666666666554 * sp[35] + 13.58333333333326 * sp[29] + -8.916666666666863 * sp[32] + 7.083333333333417 * sp[28] + 7.916666666666643 * sp[29] + 1.916666666666718 * sp[26] + 2.749999999999956 * sp[27] + 7.083333333333377 * sp[31] + 7.083333333333326 * sp[32] + 3.08333333333335 * sp[27] + -3.333333333333447 * sp[30];
    A[105] = 2.600000000000012 * sp[33] + 1.466666666666686 * sp[34] + -4.933333333333356 * sp[28] + -2.133333333333325 * sp[31] + 1.216666666666668 * sp[34] + 0.3083333333333405 * sp[35] + -1.058333333333326 * sp[29] + -0.8999999999999939 * sp[32] + 1.216666666666667 * sp[28] + 2.375000000000028 * sp[29] + -7.258333333333363 * sp[26] + -2.133333333333328 * sp[27] + 1.216666666666664 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333328 * sp[27] + -1.266666666666658 * sp[30];
    A[106] = -1.200000000000006 * sp[33] + -0.9333333333333437 * sp[34] + 2.53333333333335 * sp[28] + -3.066666666666685 * sp[31] + -0.4333333333333302 * sp[34] + 0.2166666666666575 * sp[35] + 0.2833333333333323 * sp[29] + -1.199999999999991 * sp[32] + -0.4333333333333311 * sp[28] + -1.58333333333336 * sp[29] + 3.68333333333336 * sp[26] + -3.066666666666686 * sp[27] + -0.4333333333333266 * sp[31] + -0.4333333333333468 * sp[32] + 1.433333333333335 * sp[27] + -1.633333333333326 * sp[30];
    A[107] = 0.600000000000003 * sp[33] + 0.1333333333333359 * sp[34] + -0.9333333333333422 * sp[28] + 0.5333333333333374 * sp[31] + 0.3833333333333363 * sp[34] + -0.4416666666666573 * sp[35] + -0.1416666666666695 * sp[29] + 0.09999999999999376 * sp[32] + 0.3833333333333354 * sp[28] + 0.9583333333333414 * sp[29] + -1.67500000000001 * sp[26] + 0.5333333333333425 * sp[27] + 0.3833333333333364 * sp[31] + 0.3833333333333414 * sp[32] + -0.8833333333333369 * sp[27] + 0.06666666666665966 * sp[30];
    A[108] = -2.600000000000008 * sp[33] + -1.133333333333349 * sp[34] + -7.533333333333333 * sp[28] + -3.933333333333342 * sp[31] + -1.383333333333338 * sp[34] + -0.2250000000000075 * sp[35] + -5.258333333333333 * sp[29] + -2.86666666666667 * sp[32] + -1.383333333333334 * sp[28] + -2.291666666666682 * sp[29] + 0.9416666666666662 * sp[26] + 0.03333333333332594 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333341 * sp[32] + -1.383333333333333 * sp[27] + -1.016666666666672 * sp[30];
    A[109] = 1.200000000000002 * sp[33] + 0.2666666666666755 * sp[34] + 3.73333333333333 * sp[28] + 5.866666666666658 * sp[31] + 0.7666666666666726 * sp[34] + -0.3833333333333203 * sp[35] + 3.016666666666667 * sp[29] + 3.733333333333335 * sp[32] + 0.7666666666666668 * sp[28] + 1.416666666666675 * sp[29] + -0.3833333333333352 * sp[26] + 0.2666666666666623 * sp[27] + 0.766666666666671 * sp[31] + 0.7666666666666757 * sp[32] + 0.766666666666669 * sp[27] + 1.200000000000003 * sp[30];
    A[110] = -0.5999999999999996 * sp[33] + -0.4666666666666719 * sp[34] + -1.533333333333327 * sp[28] + -1.933333333333334 * sp[31] + -0.2166666666666642 * sp[34] + 0.3583333333333236 * sp[35] + -1.008333333333328 * sp[29] + -0.8666666666666752 * sp[32] + -0.2166666666666625 * sp[28] + -1.041666666666681 * sp[29] + 0.5250000000000128 * sp[26] + -0.3000000000000148 * sp[27] + -0.2166666666666614 * sp[31] + -0.2166666666666761 * sp[32] + -0.2166666666666568 * sp[27] + -0.1833333333333493 * sp[30];
    A[111] = -5.866666666666672 * sp[33] + -7.933333333333318 * sp[34] + -2.600000000000009 * sp[28] + -3.133333333333333 * sp[31] + -3.433333333333325 * sp[34] + -5.083333333333318 * sp[35] + -0.6833333333333306 * sp[29] + -1.399999999999995 * sp[32] + -2.766666666666677 * sp[28] + -1.683333333333312 * sp[29] + -4.216666666666677 * sp[26] + -3.13333333333333 * sp[27] + -2.299999999999996 * sp[31] + -2.233333333333319 * sp[32] + -2.299999999999997 * sp[27] + -2.016666666666661 * sp[30];
    A[112] = 11.73333333333335 * sp[33] + 5.866666666666653 * sp[34] + 5.86666666666669 * sp[28] + 4.266666666666655 * sp[31] + 5.866666666666653 * sp[34] + 3.833333333333321 * sp[35] + 1.366666666666656 * sp[29] + 1.799999999999986 * sp[32] + 5.86666666666669 * sp[28] + 1.366666666666656 * sp[29] + 8.766666666666698 * sp[26] + 4.266666666666658 * sp[27] + 4.266666666666655 * sp[31] + 1.799999999999986 * sp[32] + 4.266666666666658 * sp[27] + 2.533333333333315 * sp[30];
    A[113] = -5.866666666666678 * sp[33] + 2.066666666666682 * sp[34] + -3.266666666666685 * sp[28] + 1.533333333333355 * sp[31] + -2.433333333333329 * sp[34] + 0.4166666666666574 * sp[35] + -0.5166666666666625 * sp[29] + 0.5999999999999986 * sp[32] + -3.100000000000013 * sp[28] + 3.150000000000013 * sp[29] + -4.716666666666693 * sp[26] + 1.533333333333353 * sp[27] + -1.966666666666658 * sp[31] + 1.433333333333322 * sp[32] + -1.966666666666665 * sp[27] + 0.8166666666666683 * sp[30];
    A[114] = 5.656854249492421 * sp[33] + 1.88561808316412 * sp[34] + -9.428090415820643 * sp[28] + -20.74179891480541 * sp[31] + 3.299831645537252 * sp[34] + 2.592724864350713 * sp[35] + -3.064129385141678 * sp[29] + -8.485281374238507 * sp[32] + 3.299831645537244 * sp[28] + -3.064129385141741 * sp[29] + -14.37783788412647 * sp[26] + -20.74179891480543 * sp[27] + 3.299831645537248 * sp[31] + 0.4714045207910851 * sp[32] + -8.013876853447504 * sp[27] + -11.78511301977573 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786049 * sp[34] + -16.16580753730956 * sp[28] + -36.95041722813611 * sp[31] + -1.443375672974015 * sp[34] + -19.19689645055495 * sp[35] + -5.34048999000401 * sp[29] + -15.58845726811981 * sp[32] + -1.443375672974104 * sp[28] + -12.26869322027949 * sp[29] + -26.12509968083058 * sp[26] + -36.95041722813611 * sp[27] + -1.443375672974065 * sp[31] + -10.10362971081834 * sp[32] + -15.29978213352504 * sp[27] + -21.9393102292057 * sp[30];
    A[116] = -2.000000000000023 * sp[33] + -2.666666666666662 * sp[34] + 5.333333333333357 * sp[28] + 9.333333333333353 * sp[31] + -0.1666666666666557 * sp[34] + -8.416666666666659 * sp[35] + 1.583333333333302 * sp[29] + 2.999999999999942 * sp[32] + -0.1666666666666499 * sp[28] + 3.583333333333323 * sp[29] + 5.583333333333367 * sp[26] + 9.333333333333393 * sp[27] + -0.1666666666666368 * sp[31] + -1.166666666666715 * sp[32] + 1.833333333333309 * sp[27] + 3.666666666666595 * sp[30];
    A[117] = 1.885618083164142 * sp[34] + 24.5130350811337 * sp[28] + 13.19932658214898 * sp[31] + -0.9428090415820881 * sp[34] + 0.4714045207910273 * sp[35] + 11.78511301977578 * sp[29] + 5.656854249492404 * sp[32] + -0.9428090415820765 * sp[28] + 0.4714045207910826 * sp[29] + 11.78511301977581 * sp[26] + 13.199326582149 * sp[27] + -0.9428090415820982 * sp[31] + -0.9428090415820514 * sp[32] + 10.37089945740266 * sp[27] + 8.013876853447579 * sp[30];
    A[118] = -20.78460969082659 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541326 * sp[28] + 17.32050807568865 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137781 * sp[35] + -17.3205080756888 * sp[29] + 3.464101615137646 * sp[32] + -10.39230484541327 * sp[28] + -17.32050807568893 * sp[29] + 24.24871130596431 * sp[26] + 17.32050807568862 * sp[27] + -10.39230484541326 * sp[31] + -10.39230484541332 * sp[32] + 3.464101615137738 * sp[27] + 7.794228634059805 * sp[30];
    A[119] = 3.333333333333353 * sp[34] + -12.6666666666667 * sp[28] + -4.666666666666648 * sp[31] + -1.666666666666707 * sp[34] + 0.8333333333333242 * sp[35] + -7.166666666666669 * sp[29] + -7.999999999999925 * sp[32] + -1.666666666666704 * sp[28] + 0.8333333333334174 * sp[29] + -7.166666666666758 * sp[26] + -4.666666666666632 * sp[27] + -1.666666666666734 * sp[31] + -1.666666666666648 * sp[32] + -3.6666666666667 * sp[27] + -5.833333333333231 * sp[30];
    A[120] = -1.50833333333334 * sp[33] + -0.7333333333333422 * sp[34] + 2.80000000000001 * sp[28] + 0.9833333333333261 * sp[31] + 0.3083333333333479 * sp[34] + 0.7625000000000104 * sp[35] + -2.887500000000012 * sp[29] + -0.7166666666666609 * sp[32] + 0.3083333333333363 * sp[28] + -1.187500000000014 * sp[29] + 4.295833333333356 * sp[26] + 0.9833333333333314 * sp[27] + 0.3083333333333468 * sp[31] + 0.3083333333333421 * sp[32] + -1.391666666666683 * sp[27] + -0.4083333333333338 * sp[30];
    A[121] = 1.016666666666668 * sp[33] + 1.050000000000004 * sp[34] + -1.850000000000007 * sp[28] + 2.116666666666682 * sp[31] + -0.366666666666687 * sp[34] + -1.275000000000009 * sp[35] + 2.025000000000006 * sp[29] + -2.483333333333345 * sp[32] + -0.3666666666666703 * sp[28] + 1.958333333333347 * sp[29] + -3.008333333333353 * sp[26] + 2.11666666666668 * sp[27] + -0.3666666666666815 * sp[31] + -0.3666666666666726 * sp[32] + 0.8666666666666748 * sp[27] + -1.266666666666679 * sp[30];
    A[122] = -0.09166666666667111 * sp[33] + -0.4000000000000071 * sp[34] + 0.466666666666672 * sp[28] + -1.183333333333337 * sp[31] + -0.1083333333333406 * sp[34] + 0.6374999999999883 * sp[35] + -0.5124999999999975 * sp[29] + 2.116666666666679 * sp[32] + -0.1083333333333348 * sp[28] + -1.145833333333341 * sp[29] + 0.8375000000000079 * sp[26] + -1.183333333333339 * sp[27] + -0.108333333333337 * sp[31] + -0.1083333333333398 * sp[32] + -0.1416666666666673 * sp[27] + 1.008333333333342 * sp[30];
    A[123] = 1.091666666666675 * sp[33] + 0.3583333333333455 * sp[34] + 3.225000000000008 * sp[28] + 1.34166666666668 * sp[31] + -0.01666666666666289 * sp[34] + -0.3874999999999975 * sp[35] + 0.9625000000000006 * sp[29] + 0.5583333333333393 * sp[32] + -0.01666666666666672 * sp[28] + 0.7291666666666781 * sp[29] + -1.054166666666669 * sp[26] + -0.3083333333333279 * sp[27] + -0.01666666666666833 * sp[31] + -0.01666666666666848 * sp[32] + -0.01666666666666893 * sp[27] + 0.09166666666666919 * sp[30];
    A[124] = -0.1833333333333382 * sp[33] + -0.3000000000000127 * sp[34] + -0.8666666666666717 * sp[28] + -1.933333333333338 * sp[31] + -0.2166666666666833 * sp[34] + 0.5249999999999839 * sp[35] + -1.008333333333348 * sp[29] + -1.533333333333357 * sp[32] + -0.2166666666666679 * sp[28] + -1.041666666666677 * sp[29] + 0.3583333333333346 * sp[26] + -0.4666666666666703 * sp[27] + -0.2166666666666752 * sp[31] + -0.2166666666666747 * sp[32] + -0.2166666666666751 * sp[27] + -0.6000000000000137 * sp[30];
    A[125] = 0.5083333333333313 * sp[33] + 0.775000000000003 * sp[34] + 0.9749999999999953 * sp[28] + 0.5916666666666676 * sp[31] + -0.1833333333333421 * sp[34] + -1.012499999999999 * sp[35] + 0.1708333333333183 * sp[29] + 0.9749999999999994 * sp[32] + -0.1833333333333359 * sp[28] + 1.604166666666675 * sp[29] + -1.012500000000011 * sp[26] + 0.7750000000000078 * sp[27] + -0.18333333333334 * sp[31] + -0.1833333333333331 * sp[32] + -0.1833333333333441 * sp[27] + 0.5083333333333359 * sp[30];
    A[126] = 2.183333333333341 * sp[33] + 2.424999999999999 * sp[34] + 1.091666666666673 * sp[28] + 0.8583333333333339 * sp[31] + -0.2416666666666683 * sp[34] + 1.625000000000021 * sp[35] + -1.075 * sp[29] + 0.1583333333333449 * sp[32] + 1.091666666666676 * sp[28] + 0.2583333333333242 * sp[29] + 1.691666666666678 * sp[26] + 0.8583333333333337 * sp[27] + -0.4750000000000057 * sp[31] + 0.1583333333333411 * sp[32] + -0.4750000000000058 * sp[27] + -0.0333333333333318 * sp[30];
    A[127] = -5.866666666666678 * sp[33] + -2.433333333333329 * sp[34] + -3.100000000000013 * sp[28] + -1.966666666666658 * sp[31] + 2.066666666666682 * sp[34] + 0.4166666666666574 * sp[35] + 3.150000000000013 * sp[29] + 1.433333333333322 * sp[32] + -3.266666666666685 * sp[28] + -0.5166666666666625 * sp[29] + -4.716666666666693 * sp[26] + -1.966666666666665 * sp[27] + 1.533333333333355 * sp[31] + 0.5999999999999986 * sp[32] + 1.533333333333353 * sp[27] + 0.8166666666666683 * sp[30];
    A[128] = 3.683333333333338 * sp[33] + -1.825000000000015 * sp[34] + 2.175000000000008 * sp[28] + -1.05833333333335 * sp[31] + -1.825000000000015 * sp[34] + 2.70833333333334 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666677 * sp[32] + 2.175000000000008 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666689 * sp[26] + -1.058333333333345 * sp[27] + -1.05833333333335 * sp[31] + 1.241666666666677 * sp[32] + -1.058333333333345 * sp[27] + 0.6333333333333423 * sp[30];
    A[129] = -1.649915822768645 * sp[33] + 4.949747468305825 * sp[34] + 3.535533905932746 * sp[28] + 11.5494107593803 * sp[31] + -0.4714045207910645 * sp[34] + -13.0814754519512 * sp[35] + -3.181980515339478 * sp[29] + -11.07800623858925 * sp[32] + -0.4714045207910409 * sp[28] + 6.246109900481178 * sp[29] + 4.831896338108091 * sp[26] + 11.54941075938031 * sp[27] + -0.4714045207910435 * sp[31] + -6.128258770283465 * sp[32] + -1.885618083164157 * sp[27] + -5.892556509887937 * sp[30];
    A[130] = -13.13471862406397 * sp[33] + 12.12435565298216 * sp[34] + 5.196152422706665 * sp[28] + 17.03183294109401 * sp[31] + -0.7216878364868773 * sp[34] + -6.278684177437071 * sp[35] + -4.546633369868304 * sp[29] + -12.41303078757693 * sp[32] + -0.721687836486977 * sp[28] + 9.021097956087885 * sp[29] + 7.289047148519061 * sp[26] + 17.03183294109402 * sp[27] + -0.7216878364869284 * sp[31] + -5.051814855409193 * sp[32] + -2.453738644055949 * sp[27] + -7.07254079757297 * sp[30];
    A[131] = 3.083333333333326 * sp[33] + -9.500000000000027 * sp[34] + -3.500000000000004 * sp[28] + -11.33333333333335 * sp[31] + -1.583333333333422 * sp[34] + 13.37500000000006 * sp[35] + 3.375000000000066 * sp[29] + 17.66666666666675 * sp[32] + -1.583333333333356 * sp[28] + -8.458333333333343 * sp[29] + -4.458333333333359 * sp[26] + -11.33333333333337 * sp[27] + -1.583333333333394 * sp[31] + 3.916666666666722 * sp[32] + 2.416666666666714 * sp[27] + 8.583333333333405 * sp[30];
    A[132] = -2.357022603955141 * sp[33] + -2.121320343559625 * sp[34] + -13.43502884254443 * sp[28] + -5.421151989096901 * sp[31] + 1.649915822768712 * sp[34] + 2.121320343559717 * sp[35] + 3.535533905932831 * sp[29] + 3.064129385141747 * sp[32] + 1.649915822768626 * sp[28] + -2.592724864350687 * sp[29] + -1.178511301977581 * sp[26] + -5.421151989096927 * sp[27] + 1.649915822768675 * sp[31] + 1.649915822768651 * sp[32] + 3.064129385141797 * sp[27] + 1.88561808316417 * sp[30];
    A[133] = 10.39230484541331 * sp[33] + 3.03108891324561 * sp[34] + 3.031088913245566 * sp[28] + -10.82531754730541 * sp[31] + -1.299038105676699 * sp[34] + -2.598076211353374 * sp[35] + 4.330127018922271 * sp[29] + 4.763139720814371 * sp[32] + -1.299038105676677 * sp[28] + 4.330127018922285 * sp[29] + -16.45448267190438 * sp[26] + -10.82531754730542 * sp[27] + -1.29903810567672 * sp[31] + -1.299038105676714 * sp[32] + 0.4330127018922756 * sp[27] + 2.598076211353326 * sp[30];
    A[134] = -4.166666666666638 * sp[33] + -3.749999999999963 * sp[34] + 4.250000000000034 * sp[28] + 1.916666666666705 * sp[31] + 2.916666666666839 * sp[34] + 3.750000000000124 * sp[35] + -2.249999999999933 * sp[29] + -13.08333333333321 * sp[32] + 2.9166666666667 * sp[28] + -4.583333333333351 * sp[29] + 9.416666666666737 * sp[26] + 1.916666666666674 * sp[27] + 2.916666666666778 * sp[31] + 2.916666666666734 * sp[32] + -1.083333333333296 * sp[27] + -6.66666666666662 * sp[30];
    A[135] = 1.649915822768648 * sp[33] + 3.064129385141741 * sp[34] + -1.649915822768629 * sp[28] + -1.649915822768631 * sp[31] + 0.4714045207910273 * sp[34] + 1.767766952966346 * sp[35] + 5.06759859850361 * sp[29] + -0.2357022603955496 * sp[32] + -5.185449728701356 * sp[28] + -3.889087296526053 * sp[29] + 10.72445284799599 * sp[26] + 4.006938426723752 * sp[27] + -5.185449728701383 * sp[31] + -5.185449728701424 * sp[32] + 17.44196726926821 * sp[27] + 5.892556509887863 * sp[30];
    A[136] = 3.77123616632826 * sp[33] + -3.771236166328295 * sp[34] + 0.9428090415820849 * sp[28] + 0.9428090415820771 * sp[31] + 6.128258770283455 * sp[34] + 1.178511301977608 * sp[35] + -5.421151989096847 * sp[29] + 12.25651754056689 * sp[32] + 3.299831645537228 * sp[28] + -1.64991582276857 * sp[29] + -2.592724864350695 * sp[26] + 3.771236166328277 * sp[27] + 3.299831645537251 * sp[31] + 3.299831645537293 * sp[32] + -8.956685895029631 * sp[27] + 11.78511301977581 * sp[30];
    A[137] = 4.006938426723792 * sp[33] + 10.13519719700724 * sp[34] + -4.006938426723807 * sp[28] + -4.006938426723791 * sp[31] + 5.185449728701373 * sp[34] + 7.660323462854305 * sp[35] + -3.181980515339495 * sp[29] + -16.7348604880817 * sp[32] + -0.4714045207910307 * sp[28] + 2.003469213361893 * sp[29] + 2.47487373415292 * sp[26] + 1.649915822768595 * sp[27] + -0.4714045207910284 * sp[31] + -0.4714045207910381 * sp[32] + 3.299831645537234 * sp[27] + -5.89255650988791 * sp[30];
    A[138] = -7.542472332656567 * sp[33] + -7.778174593052068 * sp[34] + -8.720983634634145 * sp[28] + -7.778174593052059 * sp[31] + -8.720983634634127 * sp[34] + -8.249579113843062 * sp[35] + -12.96362432175341 * sp[29] + -11.07800623858926 * sp[32] + 4.006938426723765 * sp[28] + 4.478342947514809 * sp[29] + -0.2357022603955121 * sp[26] + 0.2357022603955192 * sp[27] + 4.006938426723776 * sp[31] + 4.006938426723806 * sp[32] + 4.006938426723768 * sp[27] + 2.357022603955168 * sp[30];
    A[139] = 8.013876853447588 * sp[33] + 13.19932658214896 * sp[34] + 5.65685424949239 * sp[28] + 13.19932658214892 * sp[31] + 10.37089945740276 * sp[34] + 11.78511301977585 * sp[35] + 11.78511301977581 * sp[29] + 24.51303508113374 * sp[32] + -0.9428090415820536 * sp[28] + 0.4714045207910482 * sp[29] + 0.4714045207910345 * sp[26] + 1.88561808316416 * sp[27] + -0.9428090415820456 * sp[31] + -0.9428090415820688 * sp[32] + -0.9428090415820389 * sp[27];
    A[140] = 1.885618083164129 * sp[33] + -5.42115198909691 * sp[34] + 3.064129385141716 * sp[28] + -5.421151989096911 * sp[31] + 3.064129385141721 * sp[34] + -1.178511301977587 * sp[35] + 3.535533905932771 * sp[29] + -13.43502884254444 * sp[32] + 1.649915822768605 * sp[28] + -2.592724864350657 * sp[29] + 2.121320343559636 * sp[26] + -2.121320343559625 * sp[27] + 1.649915822768616 * sp[31] + 1.649915822768645 * sp[32] + 1.649915822768613 * sp[27] + -2.357022603955114 * sp[30];
    A[141] = -4.006938426723776 * sp[33] + -5.18544972870135 * sp[34] + -5.185449728701388 * sp[28] + -5.185449728701376 * sp[31] + -6.835365551469938 * sp[34] + -18.97403196183912 * sp[35] + -4.360491817317055 * sp[29] + -10.8423039781938 * sp[32] + 5.892556509887898 * sp[28] + 5.067598598503546 * sp[29] + 8.367430244040804 * sp[26] + 7.542472332656487 * sp[27] + 9.192388155425125 * sp[31] + 5.421151989096768 * sp[32] + 9.192388155425128 * sp[27] + 5.892556509887863 * sp[30];
    A[142] = 5.656854249492421 * sp[33] + 3.299831645537252 * sp[34] + 3.299831645537244 * sp[28] + 3.299831645537248 * sp[31] + 1.88561808316412 * sp[34] + 2.592724864350713 * sp[35] + -3.064129385141741 * sp[29] + 0.4714045207910851 * sp[32] + -9.428090415820643 * sp[28] + -3.064129385141678 * sp[29] + -14.37783788412647 * sp[26] + -8.013876853447504 * sp[27] + -20.74179891480541 * sp[31] + -8.485281374238507 * sp[32] + -20.74179891480543 * sp[27] + -11.78511301977573 * sp[30];
    A[143] = -1.649915822768645 * sp[33] + -0.4714045207910645 * sp[34] + -0.4714045207910409 * sp[28] + -0.4714045207910435 * sp[31] + 4.949747468305825 * sp[34] + -13.0814754519512 * sp[35] + 6.246109900481178 * sp[29] + -6.128258770283465 * sp[32] + 3.535533905932746 * sp[28] + -3.181980515339478 * sp[29] + 4.831896338108091 * sp[26] + -1.885618083164157 * sp[27] + 11.5494107593803 * sp[31] + -11.07800623858925 * sp[32] + 11.54941075938031 * sp[27] + -5.892556509887937 * sp[30];
    A[144] = 26.66666666666686 * sp[33] + 33.3333333333335 * sp[34] + -6.666666666666689 * sp[28] + -6.666666666666705 * sp[31] + 33.3333333333335 * sp[34] + 113.3333333333338 * sp[35] + -6.666666666666563 * sp[29] + 33.33333333333338 * sp[32] + -6.666666666666689 * sp[28] + -6.666666666666563 * sp[29] + 33.33333333333327 * sp[26] + 33.33333333333333 * sp[27] + -6.666666666666705 * sp[31] + 33.33333333333338 * sp[32] + 33.33333333333333 * sp[27] + 66.66666666666656 * sp[30];
    A[145] = 4.082482904638951 * sp[33] + -4.082482904638407 * sp[34] + -28.57738033247058 * sp[28] + -28.57738033247053 * sp[31] + 8.164965809277515 * sp[34] + 14.28869016623513 * sp[35] + -34.70110468942831 * sp[29] + -4.082482904638731 * sp[32] + 8.164965809277252 * sp[28] + 14.28869016623506 * sp[29] + 63.27848502189866 * sp[26] + 69.40220937885668 * sp[27] + 8.16496580927695 * sp[31] + 57.15476066494027 * sp[32] + 57.15476066494082 * sp[27] + 102.0620726159656 * sp[30];
    A[146] = 25.92724864350682 * sp[33] + 16.49915822768624 * sp[34] + -25.92724864350699 * sp[28] + -25.92724864350686 * sp[31] + 37.71236166328272 * sp[34] + -64.81812160876702 * sp[35] + -36.53385036130529 * sp[29] + -124.9221980096239 * sp[32] + 9.428090415820661 * sp[28] + 20.03469213361894 * sp[29] + -8.249579113843113 * sp[26] + 2.35702260395508 * sp[27] + 9.428090415820746 * sp[31] + -18.85618083164131 * sp[32] + -18.85618083164136 * sp[27] + -58.92556509887899 * sp[30];
    A[147] = -33.33333333333349 * sp[33] + -26.66666666666676 * sp[34] + 13.33333333333358 * sp[28] + 13.33333333333354 * sp[31] + -46.66666666666695 * sp[34] + -36.66666666666691 * sp[35] + 3.333333333333307 * sp[29] + 13.33333333333333 * sp[32] + -6.666666666666694 * sp[28] + 3.333333333333185 * sp[29] + -36.66666666666669 * sp[26] + -26.66666666666683 * sp[27] + -6.666666666666782 * sp[31] + -6.666666666666861 * sp[32] + -46.66666666666684 * sp[27] + -33.33333333333362 * sp[30];
    A[148] = -36.74234614174796 * sp[33] + -24.49489742783199 * sp[34] + -24.49489742783203 * sp[28] + -36.74234614174772 * sp[34] + -30.61862178478959 * sp[35] + -6.12372435695822 * sp[29] + 36.74234614174773 * sp[28] + 42.86607049870582 * sp[29] + -30.61862178478965 * sp[26] + -24.49489742783147 * sp[27] + 36.74234614174783 * sp[31] + 36.7423461417481 * sp[32] + -12.24744871391606 * sp[27] + -36.74234614174713 * sp[30];
    A[149] = -58.92556509887923 * sp[33] + -47.14045207910332 * sp[34] + -18.85618083164126 * sp[28] + -4.714045207910191 * sp[31] + -82.495791138431 * sp[34] + -64.81812160876723 * sp[35] + -22.3917147375741 * sp[29] + 80.13876853447557 * sp[32] + -11.78511301977581 * sp[28] + 5.892556509887648 * sp[29] + -8.249579113842987 * sp[26] + 9.428090415820513 * sp[27] + -11.78511301977596 * sp[31] + -11.78511301977611 * sp[32] + 16.49915822768607 * sp[27] + 54.21151989096815 * sp[30];
    A[150] = 10.96965511460293 * sp[33] + 0.1443375672973413 * sp[34] + 0.7216878364870857 * sp[28] + 0.7216878364870798 * sp[31] + 0.7216878364869752 * sp[34] + -1.732050807568894 * sp[35] + 11.54700538379247 * sp[29] + 5.051814855409184 * sp[32] + -10.5366424127107 * sp[28] + -8.660254037844483 * sp[29] + 18.47520861406806 * sp[26] + 7.649891066762525 * sp[27] + -10.53664241271074 * sp[31] + -10.53664241271079 * sp[32] + 29.30052616137358 * sp[27] + 10.96965511460285 * sp[30];
    A[151] = -8.948929172439174 * sp[33] + -3.175426480542823 * sp[34] + 1.443375672974014 * sp[28] + 1.443375672973947 * sp[31] + -1.443375672973963 * sp[34] + 2.020725942163682 * sp[35] + -7.216878364870303 * sp[29] + 10.10362971081836 * sp[32] + 3.752776749732562 * sp[28] + -1.443375672973955 * sp[29] + -3.752776749732616 * sp[26] + 4.907477288111845 * sp[27] + 3.752776749732618 * sp[31] + 3.75277674973267 * sp[32] + -12.41303078757702 * sp[27] + 14.14508159514585 * sp[30];
    A[152] = -0.577350269189568 * sp[33] + 4.474464586219653 * sp[34] + -0.7216878364870516 * sp[28] + -0.7216878364870305 * sp[31] + -0.721687836486982 * sp[34] + 4.041451884327479 * sp[35] + -5.051814855409194 * sp[32] + -3.319764047840363 * sp[28] + -2.886751345948163 * sp[29] + 6.92820323027554 * sp[26] + 6.206515393788466 * sp[27] + -3.319764047840347 * sp[31] + -3.319764047840345 * sp[32] + 7.649891066762572 * sp[27] + -0.5773502691896146 * sp[30];
    A[153] = -5.917840259193747 * sp[33] + -0.8660254037844877 * sp[34] + -11.83568051838745 * sp[28] + -0.8660254037845783 * sp[31] + 0.7216878364869923 * sp[34] + -2.237232293109841 * sp[35] + 18.25870226312187 * sp[29] + 10.96965511460281 * sp[32] + 11.98001808568476 * sp[28] + 13.35122497501013 * sp[29] + 2.670244995002064 * sp[26] + 4.04145188432741 * sp[27] + 11.98001808568476 * sp[31] + 11.98001808568479 * sp[32] + 11.98001808568476 * sp[27] + 8.804591605141807 * sp[30];
    A[154] = -1.154700538379172 * sp[33] + 4.618802153517112 * sp[34] + -5.196152422706532 * sp[28] + 4.618802153517141 * sp[31] + -1.443375672973972 * sp[34] + 5.917840259193776 * sp[35] + -14.86676943163276 * sp[29] + -16.16580753730939 * sp[32] + -6.639528095680715 * sp[28] + -7.938566201357379 * sp[29] + -1.010362971081855 * sp[26] + -2.309401076758483 * sp[27] + -6.639528095680678 * sp[31] + -6.63952809568069 * sp[32] + -6.639528095680663 * sp[27] + -10.3923048454132 * sp[30];
    A[155] = -4.47446458621957 * sp[33] + -3.752776749732504 * sp[34] + -8.948929172439181 * sp[28] + -3.752776749732487 * sp[31] + -0.7216878364869789 * sp[34] + -0.07216878364873935 * sp[35] + 0.2165063509461903 * sp[29] + 5.196152422706637 * sp[32] + 1.876388374866266 * sp[28] + -1.804219591217512 * sp[29] + 1.948557158514961 * sp[26] + -1.732050807568799 * sp[27] + 1.876388374866292 * sp[31] + 1.876388374866327 * sp[32] + 1.876388374866291 * sp[27] + 1.587713240271555 * sp[30];
    A[156] = 2.742413778650681 * sp[33] + 0.7216878364868515 * sp[34] + 0.721687836487015 * sp[28] + 0.7216878364869777 * sp[31] + 17.89785834487833 * sp[34] + 24.75389279150508 * sp[35] + 2.525907427704556 * sp[29] + 5.051814855409161 * sp[32] + 10.9696551146029 * sp[28] + 9.165435523385241 * sp[29] + 18.11436469582451 * sp[26] + 16.31014510460691 * sp[27] + 19.9185842870421 * sp[31] + 19.34123401785236 * sp[32] + 19.91858428704211 * sp[27] + 17.46484564298616 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974015 * sp[34] + -1.443375672974104 * sp[28] + -1.443375672974065 * sp[31] + -30.02221399786049 * sp[34] + -19.19689645055495 * sp[35] + -12.26869322027949 * sp[29] + -10.10362971081834 * sp[32] + -16.16580753730956 * sp[28] + -5.34048999000401 * sp[29] + -26.12509968083058 * sp[26] + -15.29978213352504 * sp[27] + -36.95041722813611 * sp[31] + -15.58845726811981 * sp[32] + -36.95041722813611 * sp[27] + -21.9393102292057 * sp[30];
    A[158] = -13.13471862406397 * sp[33] + -0.7216878364868773 * sp[34] + -0.721687836486977 * sp[28] + -0.7216878364869284 * sp[31] + 12.12435565298216 * sp[34] + -6.278684177437071 * sp[35] + 9.021097956087885 * sp[29] + -5.051814855409193 * sp[32] + 5.196152422706665 * sp[28] + -4.546633369868304 * sp[29] + 7.289047148519061 * sp[26] + -2.453738644055949 * sp[27] + 17.03183294109401 * sp[31] + -12.41303078757693 * sp[32] + 17.03183294109402 * sp[27] + -7.07254079757297 * sp[30];
    A[159] = 4.082482904638951 * sp[33] + 8.164965809277515 * sp[34] + 8.164965809277252 * sp[28] + 8.16496580927695 * sp[31] + -4.082482904638407 * sp[34] + 14.28869016623513 * sp[35] + 14.28869016623506 * sp[29] + 57.15476066494027 * sp[32] + -28.57738033247058 * sp[28] + -34.70110468942831 * sp[29] + 63.27848502189866 * sp[26] + 57.15476066494082 * sp[27] + -28.57738033247053 * sp[31] + -4.082482904638731 * sp[32] + 69.40220937885668 * sp[27] + 102.0620726159656 * sp[30];
    A[160] = 189.9999999999995 * sp[33] + 57.49999999999883 * sp[34] + 12.49999999999979 * sp[28] + 12.49999999999929 * sp[31] + 57.49999999999883 * sp[34] + 132.4999999999988 * sp[35] + 12.49999999999966 * sp[29] + 87.49999999999915 * sp[32] + 12.49999999999979 * sp[28] + 12.49999999999966 * sp[29] + 132.4999999999999 * sp[26] + 132.5 * sp[27] + 12.49999999999929 * sp[31] + 87.49999999999915 * sp[32] + 132.5 * sp[27] + 189.9999999999999 * sp[30];
    A[161] = -31.75426480542917 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870597 * sp[28] + -7.216878364870436 * sp[31] + -7.216878364869801 * sp[34] + 57.73502691896259 * sp[35] + -28.86751345948152 * sp[29] + -50.51814855409195 * sp[32] + 1.443375672974018 * sp[28] + 23.09401076758514 * sp[29] + 5.77350269189632 * sp[26] + 27.42413778650719 * sp[27] + 1.443375672974261 * sp[31] + 10.10362971081858 * sp[32] + -15.87713240271479 * sp[27] + -31.75426480542926 * sp[30];
    A[162] = 28.57738033247005 * sp[33] + -4.082482904639258 * sp[34] + 69.40220937885675 * sp[28] + -4.082482904638921 * sp[31] + 8.164965809276685 * sp[34] + -22.4536559755128 * sp[35] + -22.45365597551278 * sp[29] + -28.57738033247049 * sp[32] + 8.164965809277358 * sp[28] + 26.53613888015089 * sp[29] + -71.44345083117614 * sp[26] + -53.0722777603026 * sp[27] + 8.164965809277097 * sp[31] + 8.164965809276961 * sp[32] + -89.81462390205024 * sp[27] + -69.40220937885726 * sp[30];
    A[163] = -67.50000000000048 * sp[33] + 7.500000000000032 * sp[34] + 7.499999999999023 * sp[28] + 52.50000000000023 * sp[31] + 3.750000000000035 * sp[35] + 48.74999999999953 * sp[29] + -22.49999999999963 * sp[32] + 90.00000000000024 * sp[28] + 93.75000000000045 * sp[29] + -41.24999999999975 * sp[26] + -37.49999999999945 * sp[27] + 90.00000000000037 * sp[31] + 90.00000000000071 * sp[32] + -30.00000000000016 * sp[27] + -67.49999999999929 * sp[30];
    A[164] = 50.51814855409167 * sp[33] + -7.216878364871437 * sp[34] + 44.74464586219582 * sp[28] + 105.3664241271055 * sp[31] + 14.43375672973963 * sp[34] + -39.69283100678734 * sp[35] + 72.89047148518968 * sp[29] + 62.06515393788342 * sp[32] + 14.43375672974086 * sp[28] + 46.90970937165672 * sp[29] + -13.71206889325343 * sp[26] + 18.76388374866249 * sp[27] + 14.4337567297404 * sp[31] + 14.43375672974012 * sp[32] + 31.75426480542938 * sp[27] + 50.51814855409125 * sp[30];
    A[165] = -6.833333333333346 * sp[33] + 2.416666666666682 * sp[34] + 0.08333333333332001 * sp[28] + 0.08333333333330037 * sp[31] + 1.583333333333338 * sp[34] + 3.75 * sp[35] + -4.916666666666647 * sp[29] + 0.5833333333333779 * sp[32] + 0.08333333333333037 * sp[28] + -1.250000000000009 * sp[29] + -5.916666666666699 * sp[26] + -0.9166666666666465 * sp[27] + 0.0833333333333437 * sp[31] + 0.08333333333338611 * sp[32] + -10.91666666666671 * sp[27] + -1.833333333333291 * sp[30];
    A[166] = 11.1666666666667 * sp[33] + -8.166666666666712 * sp[34] + 3.166666666666703 * sp[28] + 3.166666666666733 * sp[31] + 1.833333333333356 * sp[34] + -16.66666666666674 * sp[35] + 10.66666666666669 * sp[29] + -7.833333333333411 * sp[32] + -5.166666666666718 * sp[28] + 3.333333333333383 * sp[29] + 2.666666666666668 * sp[26] + -4.833333333333391 * sp[27] + -5.166666666666707 * sp[31] + -5.166666666666746 * sp[32] + 10.16666666666669 * sp[27] + -17.16666666666675 * sp[30];
    A[167] = 4.833333333333342 * sp[33] + 14.91666666666673 * sp[34] + -4.08333333333337 * sp[28] + -4.083333333333366 * sp[31] + 2.416666666666693 * sp[34] + 22.91666666666679 * sp[35] + -5.750000000000027 * sp[29] + 11.41666666666674 * sp[32] + -4.08333333333337 * sp[28] + -12.08333333333345 * sp[29] + 3.25000000000004 * sp[26] + 4.916666666666712 * sp[27] + -4.083333333333353 * sp[31] + -4.083333333333332 * sp[32] + 1.583333333333347 * sp[27] + 19.83333333333344 * sp[30];
    A[168] = -3.583333333333354 * sp[33] + -7.000000000000024 * sp[34] + -2.666666666666649 * sp[28] + -6.999999999999984 * sp[31] + -4.916666666666697 * sp[34] + -7.708333333333363 * sp[35] + 4.458333333333289 * sp[29] + 2.166666666666598 * sp[32] + 6.583333333333396 * sp[28] + 7.291666666666713 * sp[29] + 5.458333333333387 * sp[26] + 6.16666666666671 * sp[27] + 6.583333333333364 * sp[31] + 6.583333333333314 * sp[32] + 6.583333333333383 * sp[27] + 6.91666666666667 * sp[30];
    A[169] = 9.666666666666703 * sp[33] + 17.33333333333341 * sp[34] + 6.999999999999967 * sp[28] + 17.33333333333335 * sp[31] + 4.833333333333361 * sp[34] + 24.58333333333346 * sp[35] + -11.41666666666666 * sp[29] + -2.666666666666629 * sp[32] + -8.166666666666748 * sp[28] + -15.4166666666668 * sp[29] + -3.416666666666693 * sp[26] + -10.66666666666676 * sp[27] + -8.166666666666721 * sp[31] + -8.166666666666675 * sp[32] + -8.166666666666703 * sp[27] + -18.0000000000001 * sp[30];
    A[170] = 5.583333333333337 * sp[33] + -10.33333333333339 * sp[34] + 10.6666666666667 * sp[28] + -10.33333333333339 * sp[31] + 0.9166666666666845 * sp[34] + -18.95833333333341 * sp[35] + 4.875000000000029 * sp[29] + 0.5 * sp[32] + -2.583333333333355 * sp[28] + 6.04166666666674 * sp[29] + -4.125000000000037 * sp[26] + 4.500000000000076 * sp[27] + -2.583333333333346 * sp[31] + -2.583333333333369 * sp[32] + -2.58333333333335 * sp[27] + 11.08333333333335 * sp[30];
    A[171] = -1.0833333333333 * sp[33] + -2.416666666666613 * sp[34] + -2.4166666666667 * sp[28] + -2.416666666666679 * sp[31] + 12.16666666666668 * sp[34] + 27.95833333333339 * sp[35] + -2.20833333333334 * sp[29] + 8.083333333333396 * sp[32] + -1.833333333333353 * sp[28] + -2.041666666666655 * sp[29] + 1.791666666666695 * sp[26] + 1.58333333333336 * sp[27] + 1.999999999999988 * sp[31] + 14.3333333333335 * sp[32] + 2.0 * sp[27] + 9.416666666666757 * sp[30];
    A[172] = -2.000000000000023 * sp[33] + -0.1666666666666557 * sp[34] + -0.1666666666666499 * sp[28] + -0.1666666666666368 * sp[31] + -2.666666666666662 * sp[34] + -8.416666666666659 * sp[35] + 3.583333333333323 * sp[29] + -1.166666666666715 * sp[32] + 5.333333333333357 * sp[28] + 1.583333333333302 * sp[29] + 5.583333333333367 * sp[26] + 1.833333333333309 * sp[27] + 9.333333333333353 * sp[31] + 2.999999999999942 * sp[32] + 9.333333333333393 * sp[27] + 3.666666666666595 * sp[30];
    A[173] = 3.083333333333326 * sp[33] + -1.583333333333422 * sp[34] + -1.583333333333356 * sp[28] + -1.583333333333394 * sp[31] + -9.500000000000027 * sp[34] + 13.37500000000006 * sp[35] + -8.458333333333343 * sp[29] + 3.916666666666722 * sp[32] + -3.500000000000004 * sp[28] + 3.375000000000066 * sp[29] + -4.458333333333359 * sp[26] + 2.416666666666714 * sp[27] + -11.33333333333335 * sp[31] + 17.66666666666675 * sp[32] + -11.33333333333337 * sp[27] + 8.583333333333405 * sp[30];
    A[174] = 25.92724864350682 * sp[33] + 37.71236166328272 * sp[34] + 9.428090415820661 * sp[28] + 9.428090415820746 * sp[31] + 16.49915822768624 * sp[34] + -64.81812160876702 * sp[35] + 20.03469213361894 * sp[29] + -18.85618083164131 * sp[32] + -25.92724864350699 * sp[28] + -36.53385036130529 * sp[29] + -8.249579113843113 * sp[26] + -18.85618083164136 * sp[27] + -25.92724864350686 * sp[31] + -124.9221980096239 * sp[32] + 2.35702260395508 * sp[27] + -58.92556509887899 * sp[30];
    A[175] = -31.75426480542917 * sp[33] + -7.216878364869801 * sp[34] + 1.443375672974018 * sp[28] + 1.443375672974261 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896259 * sp[35] + 23.09401076758514 * sp[29] + 10.10362971081858 * sp[32] + -7.216878364870597 * sp[28] + -28.86751345948152 * sp[29] + 5.77350269189632 * sp[26] + -15.87713240271479 * sp[27] + -7.216878364870436 * sp[31] + -50.51814855409195 * sp[32] + 27.42413778650719 * sp[27] + -31.75426480542926 * sp[30];
    A[176] = 53.33333333333346 * sp[33] + 14.16666666666683 * sp[34] + -30.8333333333336 * sp[28] + -30.83333333333351 * sp[31] + 14.16666666666683 * sp[34] + 219.1666666666675 * sp[35] + -30.83333333333356 * sp[29] + 84.16666666666714 * sp[32] + -30.8333333333336 * sp[28] + -30.83333333333356 * sp[29] + 39.1666666666671 * sp[26] + 39.16666666666697 * sp[27] + -30.83333333333351 * sp[31] + 84.16666666666714 * sp[32] + 39.16666666666697 * sp[27] + 153.333333333334 * sp[30];
    A[177] = -58.92556509887913 * sp[33] + -25.92724864350683 * sp[34] + -40.06938426723771 * sp[28] + 2.35702260395527 * sp[31] + -18.85618083164146 * sp[34] + -22.39171473757415 * sp[35] + 5.892556509887871 * sp[29] + -11.78511301977589 * sp[32] + 37.71236166328291 * sp[28] + 34.17682775735003 * sp[29] + 5.892556509887889 * sp[26] + 2.357022603955107 * sp[27] + 37.71236166328278 * sp[31] + 37.7123616632828 * sp[32] + 9.428090415820705 * sp[27] + -2.357022603955047 * sp[30];
    A[178] = 12.99038105676672 * sp[33] + -4.330127018922218 * sp[34] + -4.330127018922123 * sp[28] + -12.99038105676662 * sp[31] + -25.98076211353316 * sp[34] + 10.82531754730553 * sp[35] + 2.165063509460808 * sp[29] + 12.99038105676635 * sp[32] + 25.98076211353331 * sp[28] + 10.82531754730549 * sp[29] + 36.80607966083892 * sp[26] + 21.65063509461098 * sp[27] + 25.9807621135332 * sp[31] + 25.9807621135329 * sp[32] + -8.660254037844101 * sp[27] + 12.99038105676599 * sp[30];
    A[179] = -104.1666666666669 * sp[33] + -45.83333333333345 * sp[34] + -55.83333333333331 * sp[28] + -0.833333333333067 * sp[31] + -33.33333333333368 * sp[34] + -39.58333333333359 * sp[35] + 5.416666666666579 * sp[29] + -25.83333333333363 * sp[32] + 66.66666666666727 * sp[28] + 60.41666666666704 * sp[29] + 5.416666666666723 * sp[26] + -0.8333333333334867 * sp[27] + 66.66666666666708 * sp[31] + 66.66666666666708 * sp[32] + -3.333333333333284 * sp[27] + -104.1666666666668 * sp[30];
    A[180] = 5.892556509887893 * sp[33] + -3.299831645537247 * sp[34] + 0.4714045207910404 * sp[28] + 0.4714045207910685 * sp[31] + -1.649915822768612 * sp[34] + -2.474873734152921 * sp[35] + -2.003469213361917 * sp[29] + 0.4714045207910328 * sp[32] + 16.73486048808169 * sp[28] + 3.181980515339517 * sp[29] + -7.660323462854288 * sp[26] + -5.185449728701313 * sp[27] + 4.006938426723798 * sp[31] + 4.006938426723848 * sp[32] + -10.13519719700728 * sp[27] + -4.006938426723792 * sp[30];
    A[181] = -11.78511301977583 * sp[33] + 8.956685895029656 * sp[34] + -3.299831645537257 * sp[28] + -3.299831645537294 * sp[31] + -3.771236166328274 * sp[34] + 2.592724864350725 * sp[35] + 1.6499158227686 * sp[29] + -3.29983164553728 * sp[32] + -12.25651754056684 * sp[28] + 5.421151989096832 * sp[29] + -1.178511301977575 * sp[26] + -6.128258770283498 * sp[27] + -0.9428090415820516 * sp[31] + -0.94280904158212 * sp[32] + 3.771236166328311 * sp[27] + -3.771236166328309 * sp[30];
    A[182] = -5.892556509887917 * sp[33] + -17.44196726926827 * sp[34] + 5.185449728701398 * sp[28] + 5.185449728701393 * sp[31] + -4.006938426723782 * sp[34] + -10.72445284799603 * sp[35] + 3.889087296526027 * sp[29] + 5.185449728701382 * sp[32] + 0.2357022603955437 * sp[28] + -5.067598598503574 * sp[29] + -1.767766952966384 * sp[26] + -0.4714045207910114 * sp[27] + 1.649915822768636 * sp[31] + 1.649915822768657 * sp[32] + -3.064129385141752 * sp[27] + -1.649915822768603 * sp[30];
    A[183] = 5.892556509887943 * sp[33] + 9.19238815542516 * sp[34] + 5.421151989096883 * sp[28] + 9.192388155425126 * sp[31] + 7.542472332656526 * sp[34] + 8.367430244040808 * sp[35] + 5.067598598503627 * sp[29] + 5.892556509887905 * sp[32] + -10.84230397819378 * sp[28] + -4.360491817317088 * sp[29] + -18.9740319618391 * sp[26] + -6.835365551470035 * sp[27] + -5.185449728701402 * sp[31] + -5.185449728701423 * sp[32] + -5.185449728701383 * sp[27] + -4.006938426723817 * sp[30];
    A[184] = -11.78511301977585 * sp[33] + -20.7417989148055 * sp[34] + -8.485281374238548 * sp[28] + -20.74179891480543 * sp[31] + -8.013876853447567 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141709 * sp[29] + -9.428090415820687 * sp[32] + 0.4714045207910602 * sp[28] + -3.064129385141675 * sp[29] + 2.592724864350728 * sp[26] + 1.885618083164142 * sp[27] + 3.299831645537267 * sp[31] + 3.299831645537287 * sp[32] + 3.299831645537247 * sp[27] + 5.656854249492397 * sp[30];
    A[185] = -5.892556509887902 * sp[33] + 11.54941075938034 * sp[34] + -11.07800623858928 * sp[28] + 11.54941075938035 * sp[31] + -1.885618083164137 * sp[34] + 4.831896338108131 * sp[35] + -3.18198051533948 * sp[29] + 3.535533905932826 * sp[32] + -6.128258770283398 * sp[28] + 6.246109900481153 * sp[29] + -13.08147545195113 * sp[26] + 4.94974746830582 * sp[27] + -0.4714045207910202 * sp[31] + -0.4714045207910718 * sp[32] + -0.4714045207910007 * sp[27] + -1.649915822768632 * sp[30];
    A[186] = 2.357022603955131 * sp[33] + 4.006938426723726 * sp[34] + 4.006938426723814 * sp[28] + 4.006938426723792 * sp[31] + 0.2357022603954846 * sp[34] + -0.2357022603955086 * sp[35] + 4.478342947514788 * sp[29] + 4.006938426723767 * sp[32] + -11.07800623858928 * sp[28] + -12.9636243217534 * sp[29] + -8.249579113843065 * sp[26] + -8.720983634634095 * sp[27] + -7.778174593052078 * sp[31] + -8.720983634634081 * sp[32] + -7.778174593052094 * sp[27] + -7.542472332656549 * sp[30];
    A[187] = -0.9428090415820881 * sp[34] + -0.9428090415820765 * sp[28] + -0.9428090415820982 * sp[31] + 1.885618083164142 * sp[34] + 0.4714045207910273 * sp[35] + 0.4714045207910826 * sp[29] + -0.9428090415820514 * sp[32] + 24.5130350811337 * sp[28] + 11.78511301977578 * sp[29] + 11.78511301977581 * sp[26] + 10.37089945740266 * sp[27] + 13.19932658214898 * sp[31] + 5.656854249492404 * sp[32] + 13.199326582149 * sp[27] + 8.013876853447579 * sp[30];
    A[188] = -2.357022603955141 * sp[33] + 1.649915822768712 * sp[34] + 1.649915822768626 * sp[28] + 1.649915822768675 * sp[31] + -2.121320343559625 * sp[34] + 2.121320343559717 * sp[35] + -2.592724864350687 * sp[29] + 1.649915822768651 * sp[32] + -13.43502884254443 * sp[28] + 3.535533905932831 * sp[29] + -1.178511301977581 * sp[26] + 3.064129385141797 * sp[27] + -5.421151989096901 * sp[31] + 3.064129385141747 * sp[32] + -5.421151989096927 * sp[27] + 1.88561808316417 * sp[30];
    A[189] = -33.33333333333349 * sp[33] + -46.66666666666695 * sp[34] + -6.666666666666694 * sp[28] + -6.666666666666782 * sp[31] + -26.66666666666676 * sp[34] + -36.66666666666691 * sp[35] + 3.333333333333185 * sp[29] + -6.666666666666861 * sp[32] + 13.33333333333358 * sp[28] + 3.333333333333307 * sp[29] + -36.66666666666669 * sp[26] + -46.66666666666684 * sp[27] + 13.33333333333354 * sp[31] + 13.33333333333333 * sp[32] + -26.66666666666683 * sp[27] + -33.33333333333362 * sp[30];
    A[190] = 28.57738033247005 * sp[33] + 8.164965809276685 * sp[34] + 8.164965809277358 * sp[28] + 8.164965809277097 * sp[31] + -4.082482904639258 * sp[34] + -22.4536559755128 * sp[35] + 26.53613888015089 * sp[29] + 8.164965809276961 * sp[32] + 69.40220937885675 * sp[28] + -22.45365597551278 * sp[29] + -71.44345083117614 * sp[26] + -89.81462390205024 * sp[27] + -4.082482904638921 * sp[31] + -28.57738033247049 * sp[32] + -53.0722777603026 * sp[27] + -69.40220937885726 * sp[30];
    A[191] = -58.92556509887913 * sp[33] + -18.85618083164146 * sp[34] + 37.71236166328291 * sp[28] + 37.71236166328278 * sp[31] + -25.92724864350683 * sp[34] + -22.39171473757415 * sp[35] + 34.17682775735003 * sp[29] + 37.7123616632828 * sp[32] + -40.06938426723771 * sp[28] + 5.892556509887871 * sp[29] + 5.892556509887889 * sp[26] + 9.428090415820705 * sp[27] + 2.35702260395527 * sp[31] + -11.78511301977589 * sp[32] + 2.357022603955107 * sp[27] + -2.357022603955047 * sp[30];
    A[192] = 66.66666666666688 * sp[33] + 33.33333333333348 * sp[34] + 33.33333333333325 * sp[28] + -6.666666666666839 * sp[31] + 33.33333333333348 * sp[34] + 33.33333333333334 * sp[35] + -6.666666666666664 * sp[29] + -6.666666666666691 * sp[32] + 33.33333333333325 * sp[28] + -6.666666666666664 * sp[29] + 113.3333333333336 * sp[26] + 33.33333333333355 * sp[27] + -6.666666666666839 * sp[31] + -6.666666666666691 * sp[32] + 33.33333333333355 * sp[27] + 26.66666666666707 * sp[30];
    A[193] = 12.24744871391599 * sp[34] + 12.24744871391599 * sp[28] + 12.24744871391598 * sp[31] + 36.74234614174767 * sp[34] + 24.49489742783166 * sp[35] + 24.4948974278318 * sp[29] + 12.24744871391584 * sp[32] + -110.2270384252435 * sp[28] + -48.98979485566392 * sp[29] + -48.98979485566394 * sp[26] + 36.74234614174738 * sp[27] + -36.74234614174799 * sp[31] + -36.74234614174821 * sp[32] + 12.24744871391574 * sp[27] + 24.49489742783151 * sp[30];
    A[194] = 117.8511301977583 * sp[33] + 58.92556509887917 * sp[34] + 58.92556509887893 * sp[28] + 2.357022603954859 * sp[31] + 58.9255650988792 * sp[34] + 58.92556509887893 * sp[35] + 2.357022603955178 * sp[29] + 2.357022603954524 * sp[32] + 58.92556509887879 * sp[28] + -11.78511301977581 * sp[29] + 44.78342947514788 * sp[26] + -11.78511301977594 * sp[27] + -11.78511301977611 * sp[31] + -11.78511301977584 * sp[32] + -11.78511301977601 * sp[27] + -9.428090415820938 * sp[30];
    A[195] = -16.88749537379666 * sp[33] + -5.196152422706692 * sp[34] + 5.196152422706645 * sp[28] + 5.196152422706618 * sp[31] + -7.361215932167781 * sp[34] + -6.278684177437289 * sp[35] + 11.90784930203617 * sp[29] + 5.196152422706667 * sp[32] + -7.361215932167801 * sp[28] + 4.979646071760496 * sp[29] + -21.8671414455571 * sp[26] + -1.732050807568854 * sp[27] + 3.897114317029952 * sp[31] + 3.897114317029932 * sp[32] + -15.15544456622756 * sp[27] + -3.897114317029886 * sp[30];
    A[196] = 7.794228634059997 * sp[33] + -2.598076211353287 * sp[34] + 2.598076211353324 * sp[28] + 2.598076211353373 * sp[31] + 1.732050807568885 * sp[34] + -0.4330127018921264 * sp[35] + -2.165063509461184 * sp[29] + 2.598076211353395 * sp[32] + 1.732050807568896 * sp[28] + -5.629165124598781 * sp[29] + 13.42339375865884 * sp[26] + -0.8660254037845139 * sp[27] + -3.464101615137759 * sp[31] + -3.464101615137685 * sp[32] + 8.660254037844336 * sp[27] + -5.196152422706581 * sp[30];
    A[197] = -3.897114317030001 * sp[33] + -5.196152422706644 * sp[34] + 5.196152422706659 * sp[28] + 5.196152422706632 * sp[31] + -3.031088913245556 * sp[34] + -4.113620667976123 * sp[35] + 5.412658773652796 * sp[29] + 5.196152422706609 * sp[32] + -3.031088913245558 * sp[28] + -1.515544456622841 * sp[29] + -2.381569860407192 * sp[26] + -1.732050807568832 * sp[27] + -0.4330127018922296 * sp[31] + -0.433012701892269 * sp[32] + -2.165063509461067 * sp[27] + 0.4330127018921683 * sp[30];
    A[198] = 16.88749537379664 * sp[33] + 11.69134295108997 * sp[34] + 22.08364779650329 * sp[28] + 11.69134295108999 * sp[31] + 9.526279441628882 * sp[34] + 10.60881119635945 * sp[35] + 2.814582562299456 * sp[29] + 3.897114317030005 * sp[32] + 9.526279441628906 * sp[28] + -0.6495190528382926 * sp[29] + 36.58957330989259 * sp[26] + 19.4855715851499 * sp[27] + -1.732050807568834 * sp[31] + -1.732050807568841 * sp[32] + -1.732050807568859 * sp[27] + 0.4330127018922278 * sp[30];
    A[199] = -7.794228634059981 * sp[33] + -10.39230484541329 * sp[34] + -5.19615242270666 * sp[28] + -10.39230484541324 * sp[31] + -6.062177826491105 * sp[34] + -8.227241335952211 * sp[35] + -1.299038105676664 * sp[29] + -3.464101615137731 * sp[32] + -6.062177826491127 * sp[28] + -3.031088913245625 * sp[29] + -16.88749537379658 * sp[26] + -17.32050807568881 * sp[27] + -0.8660254037844766 * sp[31] + -0.8660254037844877 * sp[32] + -0.8660254037844569 * sp[27] + 3.464101615137753 * sp[30];
    A[200] = 3.897114317029978 * sp[33] + -1.299038105676645 * sp[34] + 9.093266739736643 * sp[28] + -1.299038105676638 * sp[31] + 0.8660254037844326 * sp[34] + -0.2165063509460512 * sp[35] + 0.6495190528383092 * sp[29] + -0.4330127018921792 * sp[32] + 0.8660254037844487 * sp[28] + -2.814582562299341 * sp[29] + 8.443747686898309 * sp[26] + -2.165063509461007 * sp[27] + -1.73205080756887 * sp[31] + -1.732050807568813 * sp[32] + -1.732050807568873 * sp[27] + -3.897114317029972 * sp[30];
    A[201] = 10.39230484541329 * sp[33] + 11.69134295108995 * sp[34] + 11.69134295108995 * sp[28] + 11.69134295108995 * sp[31] + 7.361215932167788 * sp[34] + 6.06217782649105 * sp[35] + 12.99038105676667 * sp[29] + 11.69134295108997 * sp[32] + 7.36121593216771 * sp[28] + 12.99038105676659 * sp[29] + -7.794228634059923 * sp[26] + -3.897114317029954 * sp[27] + -6.49519052838323 * sp[31] + -8.227241335952161 * sp[32] + -6.495190528383204 * sp[27] + -6.062177826491025 * sp[30];
    A[202] = -20.78460969082659 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541327 * sp[28] + -10.39230484541326 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137781 * sp[35] + -17.32050807568893 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541326 * sp[28] + -17.3205080756888 * sp[29] + 24.24871130596431 * sp[26] + 3.464101615137738 * sp[27] + 17.32050807568865 * sp[31] + 3.464101615137646 * sp[32] + 17.32050807568862 * sp[27] + 7.794228634059805 * sp[30];
    A[203] = 10.39230484541331 * sp[33] + -1.299038105676699 * sp[34] + -1.299038105676677 * sp[28] + -1.29903810567672 * sp[31] + 3.03108891324561 * sp[34] + -2.598076211353374 * sp[35] + 4.330127018922285 * sp[29] + -1.299038105676714 * sp[32] + 3.031088913245566 * sp[28] + 4.330127018922271 * sp[29] + -16.45448267190438 * sp[26] + 0.4330127018922756 * sp[27] + -10.82531754730541 * sp[31] + 4.763139720814371 * sp[32] + -10.82531754730542 * sp[27] + 2.598076211353326 * sp[30];
    A[204] = -36.74234614174796 * sp[33] + -36.74234614174772 * sp[34] + 36.74234614174773 * sp[28] + 36.74234614174783 * sp[31] + -24.49489742783199 * sp[34] + -30.61862178478959 * sp[35] + 42.86607049870582 * sp[29] + 36.7423461417481 * sp[32] + -24.49489742783203 * sp[28] + -6.12372435695822 * sp[29] + -30.61862178478965 * sp[26] + -12.24744871391606 * sp[27] + -24.49489742783147 * sp[27] + -36.74234614174713 * sp[30];
    A[205] = -67.50000000000048 * sp[33] + 90.00000000000024 * sp[28] + 90.00000000000037 * sp[31] + 7.500000000000032 * sp[34] + 3.750000000000035 * sp[35] + 93.75000000000045 * sp[29] + 90.00000000000071 * sp[32] + 7.499999999999023 * sp[28] + 48.74999999999953 * sp[29] + -41.24999999999975 * sp[26] + -30.00000000000016 * sp[27] + 52.50000000000023 * sp[31] + -22.49999999999963 * sp[32] + -37.49999999999945 * sp[27] + -67.49999999999929 * sp[30];
    A[206] = 12.99038105676672 * sp[33] + -25.98076211353316 * sp[34] + 25.98076211353331 * sp[28] + 25.9807621135332 * sp[31] + -4.330127018922218 * sp[34] + 10.82531754730553 * sp[35] + 10.82531754730549 * sp[29] + 25.9807621135329 * sp[32] + -4.330127018922123 * sp[28] + 2.165063509460808 * sp[29] + 36.80607966083892 * sp[26] + -8.660254037844101 * sp[27] + -12.99038105676662 * sp[31] + 12.99038105676635 * sp[32] + 21.65063509461098 * sp[27] + 12.99038105676599 * sp[30];
    A[207] = 36.74234614174767 * sp[34] + -110.2270384252435 * sp[28] + -36.74234614174799 * sp[31] + 12.24744871391599 * sp[34] + 24.49489742783166 * sp[35] + -48.98979485566392 * sp[29] + -36.74234614174821 * sp[32] + 12.24744871391599 * sp[28] + 24.4948974278318 * sp[29] + -48.98979485566394 * sp[26] + 12.24744871391574 * sp[27] + 12.24744871391598 * sp[31] + 12.24744871391584 * sp[32] + 36.74234614174738 * sp[27] + 24.49489742783151 * sp[30];
    A[208] = 135.0000000000008 * sp[33] + 67.50000000000044 * sp[34] + 67.50000000000048 * sp[28] + -22.49999999999977 * sp[31] + 67.50000000000044 * sp[34] + 67.50000000000067 * sp[35] + -22.49999999999999 * sp[29] + -22.49999999999982 * sp[32] + 67.50000000000048 * sp[28] + -22.49999999999999 * sp[29] + 247.4999999999999 * sp[26] + 67.49999999999997 * sp[27] + -22.49999999999977 * sp[31] + -22.49999999999982 * sp[32] + 67.49999999999997 * sp[27] + 59.99999999999972 * sp[30];
    A[209] = 64.95190528383287 * sp[34] + -38.97114317029992 * sp[28] + 12.99038105676648 * sp[31] + 21.65063509461117 * sp[34] + 43.30127018922171 * sp[35] + -8.660254037844199 * sp[29] + 12.99038105676669 * sp[32] + 21.65063509461108 * sp[28] + 43.30127018922193 * sp[29] + -8.660254037844645 * sp[26] + 99.59292143520975 * sp[27] + 21.65063509461113 * sp[31] + 21.65063509461085 * sp[32] + -12.99038105676647 * sp[27] + 43.30127018922258 * sp[30];
    A[210] = 10.41666666666666 * sp[33] + -5.83333333333338 * sp[34] + 0.8333333333333597 * sp[28] + 0.833333333333401 * sp[31] + -2.916666666666671 * sp[34] + -4.375000000000007 * sp[35] + -3.541666666666717 * sp[29] + 0.8333333333333373 * sp[32] + 10.08333333333334 * sp[28] + -2.875000000000028 * sp[29] + 7.958333333333405 * sp[26] + 1.833333333333368 * sp[27] + -1.416666666666686 * sp[31] + -1.416666666666758 * sp[32] + 3.583333333333325 * sp[27] + 2.916666666666643 * sp[30];
    A[211] = -20.83333333333339 * sp[33] + 15.83333333333343 * sp[34] + -5.833333333333398 * sp[28] + -5.833333333333455 * sp[31] + -6.666666666666699 * sp[34] + 4.583333333333418 * sp[35] + 2.916666666666646 * sp[29] + -5.83333333333343 * sp[32] + -12.66666666666667 * sp[28] + 11.58333333333335 * sp[29] + -10.0833333333334 * sp[26] + 2.166666666666629 * sp[27] + 0.3333333333333777 * sp[31] + 0.3333333333335253 * sp[32] + -1.333333333333345 * sp[27] + 13.33333333333326 * sp[30];
    A[212] = -10.4166666666667 * sp[33] + -30.83333333333348 * sp[34] + 9.166666666666753 * sp[28] + 9.166666666666742 * sp[31] + -7.08333333333335 * sp[34] + -18.95833333333342 * sp[35] + 6.875000000000025 * sp[29] + 9.166666666666719 * sp[32] + -4.083333333333326 * sp[28] + -12.45833333333336 * sp[29] + 3.375000000000038 * sp[26] + 0.1666666666666874 * sp[27] + -0.5833333333332997 * sp[31] + -0.5833333333333515 * sp[32] + 1.083333333333313 * sp[27] + -12.9166666666667 * sp[30];
    A[213] = 10.41666666666675 * sp[33] + 16.25000000000008 * sp[34] + 9.58333333333335 * sp[28] + 16.25 * sp[31] + 13.33333333333336 * sp[34] + 14.79166666666666 * sp[35] + 8.958333333333393 * sp[29] + 10.41666666666667 * sp[32] + 0.3333333333333379 * sp[28] + 3.291666666666697 * sp[29] + 7.458333333333292 * sp[26] + 9.416666666666636 * sp[27] + 1.833333333333298 * sp[31] + 1.833333333333316 * sp[32] + 1.833333333333306 * sp[27] + 2.916666666666619 * sp[30];
    A[214] = -20.83333333333343 * sp[33] + -36.66666666666684 * sp[34] + -14.99999999999995 * sp[28] + -36.66666666666672 * sp[31] + -14.16666666666671 * sp[34] + -25.41666666666674 * sp[35] + -5.416666666666665 * sp[29] + -16.66666666666675 * sp[32] + -8.166666666666673 * sp[28] + -12.4166666666667 * sp[29] + -12.41666666666661 * sp[26] + -24.66666666666664 * sp[27] + -1.166666666666608 * sp[31] + -1.166666666666637 * sp[32] + -1.166666666666613 * sp[27] + 10.00000000000008 * sp[30];
    A[215] = -10.41666666666667 * sp[33] + 20.41666666666679 * sp[34] + -19.58333333333339 * sp[28] + 20.41666666666678 * sp[31] + -3.333333333333347 * sp[34] + 8.541666666666762 * sp[35] + -5.625000000000021 * sp[29] + 6.250000000000149 * sp[32] + -6.333333333333318 * sp[28] + 12.04166666666669 * sp[29] + -12.12500000000002 * sp[26] + 15.25000000000001 * sp[27] + 0.1666666666666874 * sp[31] + 0.1666666666667926 * sp[32] + 0.1666666666667045 * sp[27] + -12.91666666666651 * sp[30];
    A[216] = 4.166666666666618 * sp[33] + 7.083333333333249 * sp[34] + 7.083333333333417 * sp[28] + 7.083333333333377 * sp[31] + 0.416666666666611 * sp[34] + -0.4166666666666554 * sp[35] + 7.916666666666643 * sp[29] + 7.083333333333326 * sp[32] + 8.416666666666657 * sp[28] + 13.58333333333326 * sp[29] + 1.916666666666718 * sp[26] + 3.08333333333335 * sp[27] + 2.749999999999959 * sp[31] + -8.916666666666863 * sp[32] + 2.749999999999956 * sp[27] + -3.333333333333447 * sp[30];
    A[217] = -1.666666666666707 * sp[34] + -1.666666666666704 * sp[28] + -1.666666666666734 * sp[31] + 3.333333333333353 * sp[34] + 0.8333333333333242 * sp[35] + 0.8333333333334174 * sp[29] + -1.666666666666648 * sp[32] + -12.6666666666667 * sp[28] + -7.166666666666669 * sp[29] + -7.166666666666758 * sp[26] + -3.6666666666667 * sp[27] + -4.666666666666648 * sp[31] + -7.999999999999925 * sp[32] + -4.666666666666632 * sp[27] + -5.833333333333231 * sp[30];
    A[218] = -4.166666666666638 * sp[33] + 2.916666666666839 * sp[34] + 2.9166666666667 * sp[28] + 2.916666666666778 * sp[31] + -3.749999999999963 * sp[34] + 3.750000000000124 * sp[35] + -4.583333333333351 * sp[29] + 2.916666666666734 * sp[32] + 4.250000000000034 * sp[28] + -2.249999999999933 * sp[29] + 9.416666666666737 * sp[26] + -1.083333333333296 * sp[27] + 1.916666666666705 * sp[31] + -13.08333333333321 * sp[32] + 1.916666666666674 * sp[27] + -6.66666666666662 * sp[30];
    A[219] = -58.92556509887923 * sp[33] + -82.495791138431 * sp[34] + -11.78511301977581 * sp[28] + -11.78511301977596 * sp[31] + -47.14045207910332 * sp[34] + -64.81812160876723 * sp[35] + 5.892556509887648 * sp[29] + -11.78511301977611 * sp[32] + -18.85618083164126 * sp[28] + -22.3917147375741 * sp[29] + -8.249579113842987 * sp[26] + 16.49915822768607 * sp[27] + -4.714045207910191 * sp[31] + 80.13876853447557 * sp[32] + 9.428090415820513 * sp[27] + 54.21151989096815 * sp[30];
    A[220] = 50.51814855409167 * sp[33] + 14.43375672973963 * sp[34] + 14.43375672974086 * sp[28] + 14.4337567297404 * sp[31] + -7.216878364871437 * sp[34] + -39.69283100678734 * sp[35] + 46.90970937165672 * sp[29] + 14.43375672974012 * sp[32] + 44.74464586219582 * sp[28] + 72.89047148518968 * sp[29] + -13.71206889325343 * sp[26] + 31.75426480542938 * sp[27] + 105.3664241271055 * sp[31] + 62.06515393788342 * sp[32] + 18.76388374866249 * sp[27] + 50.51814855409125 * sp[30];
    A[221] = -104.1666666666669 * sp[33] + -33.33333333333368 * sp[34] + 66.66666666666727 * sp[28] + 66.66666666666708 * sp[31] + -45.83333333333345 * sp[34] + -39.58333333333359 * sp[35] + 60.41666666666704 * sp[29] + 66.66666666666708 * sp[32] + -55.83333333333331 * sp[28] + 5.416666666666579 * sp[29] + 5.416666666666723 * sp[26] + -3.333333333333284 * sp[27] + -0.833333333333067 * sp[31] + -25.83333333333363 * sp[32] + -0.8333333333334867 * sp[27] + -104.1666666666668 * sp[30];
    A[222] = 117.8511301977583 * sp[33] + 58.9255650988792 * sp[34] + 58.92556509887879 * sp[28] + -11.78511301977611 * sp[31] + 58.92556509887917 * sp[34] + 58.92556509887893 * sp[35] + -11.78511301977581 * sp[29] + -11.78511301977584 * sp[32] + 58.92556509887893 * sp[28] + 2.357022603955178 * sp[29] + 44.78342947514788 * sp[26] + -11.78511301977601 * sp[27] + 2.357022603954859 * sp[31] + 2.357022603954524 * sp[32] + -11.78511301977594 * sp[27] + -9.428090415820938 * sp[30];
    A[223] = 21.65063509461117 * sp[34] + 21.65063509461108 * sp[28] + 21.65063509461113 * sp[31] + 64.95190528383287 * sp[34] + 43.30127018922171 * sp[35] + 43.30127018922193 * sp[29] + 21.65063509461085 * sp[32] + -38.97114317029992 * sp[28] + -8.660254037844199 * sp[29] + -8.660254037844645 * sp[26] + -12.99038105676647 * sp[27] + 12.99038105676648 * sp[31] + 12.99038105676669 * sp[32] + 99.59292143520975 * sp[27] + 43.30127018922258 * sp[30];
    A[224] = 208.333333333334 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666666 * sp[28] + 4.166666666666181 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666666 * sp[35] + 4.166666666666675 * sp[29] + 4.166666666665556 * sp[32] + 104.1666666666666 * sp[28] + 4.166666666666675 * sp[29] + 104.1666666666666 * sp[26] + 4.16666666666646 * sp[27] + 4.166666666666181 * sp[31] + 4.166666666665556 * sp[32] + 4.16666666666646 * sp[27] + 183.3333333333318 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698435 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.0573412698412703 * sp[17];
    A[1] = -0.02986111111111124 * sp[19] + 0.005952380952380875 * sp[18] + 0.009920634920635002 * sp[18] + -0.04871031746031775 * sp[17];
    A[2] = 0.01765873015873009 * sp[19] + -0.004712301587301555 * sp[18] + -0.00471230158730162 * sp[18] + 0.01765873015873019 * sp[17];
    A[3] = -0.0154265873015874 * sp[19] + -0.02447916666666678 * sp[18] + 0.009052579365079375 * sp[18] + 0.01860119047619061 * sp[17];
    A[4] = 0.01746031746031736 * sp[19] + 0.02167658730158715 * sp[18] + -0.005704365079365063 * sp[18] + -0.01190476190476189 * sp[17];
    A[5] = -0.02385912698412699 * sp[19] + -0.03266369047619055 * sp[18] + 0.006820436507936543 * sp[18] + 0.01116071428571419 * sp[17];
    A[6] = -0.01314484126984126 * sp[19] + -0.008804563492063528 * sp[18] + 0.03067956349206365 * sp[18] + 0.02385912698412707 * sp[17];
    A[7] = 0.02777777777777799 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285772 * sp[18] + -0.06111111111111161 * sp[17];
    A[8] = -0.0205853174603176 * sp[19] + -0.007068452380952358 * sp[18] + 0.05820932539682571 * sp[18] + 0.05114087301587341 * sp[17];
    A[9] = 0.04349267900155114 * sp[19] + -0.02314932914598859 * sp[18] + -0.06243303921190627 * sp[18] + 0.03507474113028557 * sp[17];
    A[10] = 0.06529556615835232 * sp[19] + -0.05154913117764579 * sp[18] + -0.1271545235715237 * sp[18] + 0.06529556615835085 * sp[17];
    A[11] = -0.01686507936508141 * sp[19] + -0.007440476190475746 * sp[18] + 0.0719246031746027 * sp[18] + -0.01091269841269967 * sp[17];
    A[12] = 0.03507474113028578 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429711 * sp[18] + -0.1248660784238148 * sp[17];
    A[13] = -0.1005208057964095 * sp[19] + -0.06314768569261553 * sp[18] + 0.07088005536926224 * sp[18] + -0.08505606644311364 * sp[17];
    A[14] = 0.06200396825396945 * sp[19] + 0.09598214285714186 * sp[18] + -0.02108134920634952 * sp[18] + 0.05307539682539828 * sp[17];
    A[15] = -0.02986111111111124 * sp[19] + 0.009920634920635002 * sp[18] + 0.005952380952380875 * sp[18] + -0.04871031746031775 * sp[17];
    A[16] = 0.06865079365079402 * sp[19] + -0.01289682539682544 * sp[18] + -0.01289682539682544 * sp[18] + 0.06865079365079425 * sp[17];
    A[17] = -0.04871031746031759 * sp[19] + 0.005952380952380876 * sp[18] + 0.009920634920634986 * sp[18] + -0.02986111111111132 * sp[17];
    A[18] = 0.01746031746031737 * sp[19] + 0.02316468253968247 * sp[18] + -0.004216269841269739 * sp[18] + -0.01041666666666659 * sp[17];
    A[19] = -0.04384920634920634 * sp[19] + -0.05327380952380961 * sp[18] + 0.009424603174603165 * sp[18] + 0.01785714285714283 * sp[17];
    A[20] = 0.06111111111111137 * sp[19] + 0.07524801587301629 * sp[18] + -0.01165674603174608 * sp[18] + -0.02529761904761911 * sp[17];
    A[21] = 0.01041666666666664 * sp[19] + 0.004216269841269746 * sp[18] + -0.02316468253968254 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.017857142857143 * sp[19] + -0.00942460317460324 * sp[18] + 0.05327380952380978 * sp[18] + 0.04384920634920658 * sp[17];
    A[23] = 0.02529761904761933 * sp[19] + 0.01165674603174614 * sp[18] + -0.07524801587301648 * sp[18] + -0.06111111111111168 * sp[17];
    A[24] = -0.07856742013183728 * sp[19] + -0.009820927516479887 * sp[18] + 0.1360899955855054 * sp[18] + 0.07014948226057133 * sp[17];
    A[25] = -0.05326743555023516 * sp[19] + -0.0085915218629416 * sp[18] + 0.1838585678669348 * sp[18] + 0.08419691425682245 * sp[17];
    A[26] = -0.004960317460314796 * sp[19] + 0.01984126984126904 * sp[18] + -0.1626984126984119 * sp[18] + -0.1021825396825403 * sp[17];
    A[27] = -0.07014948226057145 * sp[19] + -0.1360899955855056 * sp[18] + 0.00982092751647989 * sp[18] + 0.07856742013183692 * sp[17];
    A[28] = 0.04639421805988031 * sp[19] + 0.04897167461876184 * sp[18] + -0.01288728279441029 * sp[18] + 0.03092947870658618 * sp[17];
    A[29] = -0.1240079365079387 * sp[19] + -0.2405753968253963 * sp[18] + 0.01736111111111123 * sp[18] + 0.04365079365079537 * sp[17];
    A[30] = 0.01765873015873009 * sp[19] + -0.00471230158730162 * sp[18] + -0.004712301587301555 * sp[18] + 0.01765873015873019 * sp[17];
    A[31] = -0.04871031746031759 * sp[19] + 0.009920634920634986 * sp[18] + 0.005952380952380876 * sp[18] + -0.02986111111111132 * sp[17];
    A[32] = 0.05734126984127018 * sp[19] + -0.01116071428571434 * sp[18] + -0.01116071428571434 * sp[18] + 0.02162698412698437 * sp[17];
    A[33] = -0.02385912698412704 * sp[19] + -0.03067956349206364 * sp[18] + 0.008804563492063534 * sp[18] + 0.01314484126984126 * sp[17];
    A[34] = 0.06111111111111149 * sp[19] + 0.07276785714285768 * sp[18] + -0.01413690476190485 * sp[18] + -0.02777777777777795 * sp[17];
    A[35] = -0.05114087301587322 * sp[19] + -0.05820932539682565 * sp[18] + 0.007068452380952352 * sp[18] + 0.02058531746031755 * sp[17];
    A[36] = -0.01860119047619066 * sp[19] + -0.009052579365079395 * sp[18] + 0.02447916666666682 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.01190476190476204 * sp[19] + 0.005704365079365122 * sp[18] + -0.02167658730158726 * sp[18] + -0.01746031746031749 * sp[17];
    A[38] = -0.0111607142857144 * sp[19] + -0.006820436507936584 * sp[18] + 0.03266369047619068 * sp[18] + 0.02385912698412713 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429709 * sp[18] + -0.1283735525368425 * sp[18] + -0.03507474113028568 * sp[17];
    A[40] = -0.003436608745177203 * sp[19] + -0.01718304372588143 * sp[18] + -0.05154913117764433 * sp[18] + -0.003436608745176603 * sp[17];
    A[41] = 0.1001984126984121 * sp[19] + -0.07192460317460356 * sp[18] + 0.1026785714285715 * sp[18] + 0.1180555555555573 * sp[17];
    A[42] = -0.03507474113028564 * sp[19] + 0.06243303921190657 * sp[18] + 0.02314932914598861 * sp[18] + -0.04349267900155106 * sp[17];
    A[43] = -0.02319710902993958 * sp[19] + 0.001288728279441132 * sp[18] + 0.0322182069860282 * sp[18] + -0.01804219591217503 * sp[17];
    A[44] = -0.06200396825396921 * sp[19] + 0.1460813492063478 * sp[18] + 0.04092261904761981 * sp[18] + -0.06498015873016071 * sp[17];
    A[45] = -0.0154265873015874 * sp[19] + 0.009052579365079375 * sp[18] + -0.02447916666666678 * sp[18] + 0.01860119047619061 * sp[17];
    A[46] = 0.01746031746031737 * sp[19] + -0.004216269841269739 * sp[18] + 0.02316468253968247 * sp[18] + -0.01041666666666659 * sp[17];
    A[47] = -0.02385912698412704 * sp[19] + 0.008804563492063534 * sp[18] + -0.03067956349206364 * sp[18] + 0.01314484126984126 * sp[17];
    A[48] = 0.02162698412698432 * sp[19] + 0.03278769841269866 * sp[18] + 0.03278769841269866 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.02986111111111125 * sp[19] + -0.03581349206349217 * sp[18] + -0.0397817460317463 * sp[18] + -0.09444444444444483 * sp[17];
    A[50] = 0.01765873015873008 * sp[19] + 0.02237103174603165 * sp[18] + 0.02237103174603173 * sp[18] + 0.04474206349206337 * sp[17];
    A[51] = 0.02058531746031756 * sp[19] + 0.01351686507936519 * sp[18] + 0.07879464285714317 * sp[18] + 0.02058531746031756 * sp[17];
    A[52] = -0.02777777777777796 * sp[19] + -0.01364087301587308 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761924 * sp[17];
    A[53] = 0.01314484126984126 * sp[19] + 0.004340277777777696 * sp[18] + 0.04382440476190486 * sp[18] + 0.01116071428571426 * sp[17];
    A[54] = -0.0785674201318369 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280409 * sp[18] + 0.0420896893563428 * sp[17];
    A[55] = -0.03522523963805749 * sp[19] + 0.07947157723220398 * sp[18] + 0.02104922856420367 * sp[18] + 0.1159855451497028 * sp[17];
    A[56] = -0.04513888888888812 * sp[19] + 0.04340277777777803 * sp[18] + 0.005704365079364766 * sp[18] + 0.05208333333333283 * sp[17];
    A[57] = 0.03507474113028563 * sp[19] + -0.09329881140655687 * sp[18] + 0.04700015311458285 * sp[18] + -0.206239477846075 * sp[17];
    A[58] = 0.1005208057964093 * sp[19] + 0.03737312010379379 * sp[18] + 0.1714008611656714 * sp[18] + 0.1933092419161693 * sp[17];
    A[59] = 0.06200396825396917 * sp[19] + -0.03397817460317274 * sp[18] + 0.08308531746031883 * sp[18] + 0.0401785714285746 * sp[17];
    A[60] = 0.01746031746031736 * sp[19] + -0.005704365079365063 * sp[18] + 0.02167658730158715 * sp[18] + -0.01190476190476189 * sp[17];
    A[61] = -0.04384920634920634 * sp[19] + 0.009424603174603165 * sp[18] + -0.05327380952380961 * sp[18] + 0.01785714285714283 * sp[17];
    A[62] = 0.06111111111111149 * sp[19] + -0.01413690476190485 * sp[18] + 0.07276785714285768 * sp[18] + -0.02777777777777795 * sp[17];
    A[63] = -0.02986111111111125 * sp[19] + -0.0397817460317463 * sp[18] + -0.03581349206349217 * sp[18] + -0.09444444444444483 * sp[17];
    A[64] = 0.06865079365079416 * sp[19] + 0.08154761904761972 * sp[18] + 0.08154761904761972 * sp[18] + 0.1630952380952394 * sp[17];
    A[65] = -0.04871031746031759 * sp[19] + -0.05466269841269856 * sp[18] + -0.05863095238095267 * sp[18] + -0.09444444444444489 * sp[17];
    A[66] = -0.02529761904761933 * sp[19] + -0.0136408730158731 * sp[18] + -0.1005456349206357 * sp[18] + -0.02777777777777796 * sp[17];
    A[67] = 0.01785714285714301 * sp[19] + 0.008432539682539705 * sp[18] + 0.0711309523809526 * sp[18] + 0.0178571428571429 * sp[17];
    A[68] = -0.01041666666666667 * sp[19] + -0.006200396825396817 * sp[18] + -0.03358134920634917 * sp[18] + -0.01190476190476187 * sp[17];
    A[69] = 0.148716902392409 * sp[19] + 0.002805979290422788 * sp[18] + 0.2946278254943953 * sp[18];
    A[70] = -0.006873217490354664 * sp[19] + -0.047253370246175 * sp[18] + -0.1778445025628795 * sp[18] + -0.103098262355291 * sp[17];
    A[71] = 0.1289682539682538 * sp[19] + -0.09176587301587376 * sp[18] + -0.0163690476190468 * sp[18] + -0.1785714285714299 * sp[17];
    A[72] = -0.07014948226057141 * sp[19] + 0.06594051332493447 * sp[18] + -0.07997040977705135 * sp[18] + 0.1346870059402923 * sp[17];
    A[73] = -0.04639421805988019 * sp[19] + 0.002577456558881516 * sp[18] + -0.0592815008542904 * sp[18] + -0.04123930494211515 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.1165674603174582 * sp[18] + -0.1413690476190499 * sp[18] + 0.1428571428571432 * sp[17];
    A[75] = -0.02385912698412699 * sp[19] + 0.006820436507936543 * sp[18] + -0.03266369047619055 * sp[18] + 0.01116071428571419 * sp[17];
    A[76] = 0.06111111111111137 * sp[19] + -0.01165674603174608 * sp[18] + 0.07524801587301629 * sp[18] + -0.02529761904761911 * sp[17];
    A[77] = -0.05114087301587322 * sp[19] + 0.007068452380952352 * sp[18] + -0.05820932539682565 * sp[18] + 0.02058531746031755 * sp[17];
    A[78] = 0.01765873015873008 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603165 * sp[18] + 0.04474206349206337 * sp[17];
    A[79] = -0.04871031746031759 * sp[19] + -0.05863095238095267 * sp[18] + -0.05466269841269856 * sp[18] + -0.09444444444444489 * sp[17];
    A[80] = 0.05734126984127008 * sp[19] + 0.06850198412698448 * sp[18] + 0.06850198412698448 * sp[18] + 0.1012896825396832 * sp[17];
    A[81] = 0.01116071428571435 * sp[19] + 0.004340277777777708 * sp[18] + 0.04382440476190493 * sp[18] + 0.01314484126984124 * sp[17];
    A[82] = -0.011904761904762 * sp[19] + -0.006200396825396842 * sp[18] + -0.03358134920634907 * sp[18] + -0.01041666666666655 * sp[17];
    A[83] = 0.01860119047619066 * sp[19] + 0.009548611111111202 * sp[18] + 0.0430803571428574 * sp[18] + 0.01860119047619052 * sp[17];
    A[84] = -0.08979133729352941 * sp[19] + -0.01543288609732565 * sp[18] + -0.1950155606843834 * sp[18] + -0.04208968935634277 * sp[17];
    A[85] = -0.02663371777511715 * sp[19] + -0.01073940232867686 * sp[18] + -0.007302793583500541 * sp[18] + -0.01288728279441236 * sp[17];
    A[86] = -0.03819444444444252 * sp[19] + 0.03596230158730127 * sp[18] + 0.1054067460317485 * sp[18] + 0.1264880952380961 * sp[17];
    A[87] = -0.03507474113028564 * sp[19] + -0.09750778034219186 * sp[18] + -0.05822407027627427 * sp[18] + -0.1641497884897316 * sp[17];
    A[88] = 0.02319710902993945 * sp[19] + 0.02448583730938063 * sp[18] + 0.05541531601596756 * sp[18] + 0.07474624020758409 * sp[17];
    A[89] = -0.06200396825396917 * sp[19] + -0.2080853174603166 * sp[18] + -0.1029265873015891 * sp[18] + -0.3139880952380976 * sp[17];
    A[90] = -0.01314484126984126 * sp[19] + 0.03067956349206365 * sp[18] + -0.008804563492063528 * sp[18] + 0.02385912698412707 * sp[17];
    A[91] = 0.01041666666666664 * sp[19] + -0.02316468253968254 * sp[18] + 0.004216269841269746 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619066 * sp[19] + 0.02447916666666682 * sp[18] + -0.009052579365079395 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031756 * sp[19] + 0.07879464285714317 * sp[18] + 0.01351686507936519 * sp[18] + 0.02058531746031756 * sp[17];
    A[94] = -0.02529761904761933 * sp[19] + -0.1005456349206357 * sp[18] + -0.0136408730158731 * sp[18] + -0.02777777777777796 * sp[17];
    A[95] = 0.01116071428571435 * sp[19] + 0.04382440476190493 * sp[18] + 0.004340277777777708 * sp[18] + 0.01314484126984124 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269868 * sp[18] + 0.03278769841269868 * sp[18] + 0.02162698412698434 * sp[17];
    A[97] = -0.0944444444444448 * sp[19] + -0.03978174603174629 * sp[18] + -0.03581349206349217 * sp[18] + -0.02986111111111128 * sp[17];
    A[98] = 0.04474206349206346 * sp[19] + 0.02237103174603177 * sp[18] + 0.02237103174603172 * sp[18] + 0.01765873015873017 * sp[17];
    A[99] = -0.2062394778460755 * sp[19] + 0.04700015311458268 * sp[18] + -0.09329881140655705 * sp[18] + 0.0350747411302855 * sp[17];
    A[100] = 0.131450284502998 * sp[19] + 0.1576544261849666 * sp[18] + -0.01073940232867423 * sp[18] + 0.1039574145415857 * sp[17];
    A[101] = 0.1473214285714276 * sp[19] + 0.106894841269842 * sp[18] + 0.04935515873015902 * sp[18] + 0.05605158730158804 * sp[17];
    A[102] = 0.04208968935634283 * sp[19] + -0.152925871328041 * sp[18] + 0.02665680325901717 * sp[18] + -0.07856742013183682 * sp[17];
    A[103] = 0.1030982623552902 * sp[19] + 0.01546473935329262 * sp[18] + 0.07732369676646841 * sp[18] + -0.05670404429540916 * sp[17];
    A[104] = 0.07440476190476314 * sp[19] + 0.01537698412698315 * sp[18] + 0.04712301587301673 * sp[18] + -0.007936507936507933 * sp[17];
    A[105] = 0.02777777777777799 * sp[19] + -0.07276785714285772 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111161 * sp[17];
    A[106] = -0.017857142857143 * sp[19] + 0.05327380952380978 * sp[18] + -0.00942460317460324 * sp[18] + 0.04384920634920658 * sp[17];
    A[107] = 0.01190476190476204 * sp[19] + -0.02167658730158726 * sp[18] + 0.005704365079365122 * sp[18] + -0.01746031746031749 * sp[17];
    A[108] = -0.02777777777777796 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587308 * sp[18] + -0.02529761904761924 * sp[17];
    A[109] = 0.01785714285714301 * sp[19] + 0.0711309523809526 * sp[18] + 0.008432539682539705 * sp[18] + 0.0178571428571429 * sp[17];
    A[110] = -0.011904761904762 * sp[19] + -0.03358134920634907 * sp[18] + -0.006200396825396842 * sp[18] + -0.01041666666666655 * sp[17];
    A[111] = -0.0944444444444448 * sp[19] + -0.03581349206349217 * sp[18] + -0.03978174603174629 * sp[18] + -0.02986111111111128 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761967 * sp[18] + 0.08154761904761967 * sp[18] + 0.06865079365079423 * sp[17];
    A[113] = -0.09444444444444489 * sp[19] + -0.0586309523809528 * sp[18] + -0.05466269841269866 * sp[18] + -0.04871031746031779 * sp[17];
    A[114] = 0.1346870059402925 * sp[19] + -0.07997040977705097 * sp[18] + 0.0659405133249347 * sp[18] + -0.07014948226057102 * sp[17];
    A[115] = 0.1030982623552917 * sp[19] + -0.1520699369740541 * sp[18] + 0.1022391101689948 * sp[18] + -0.1305911323167022 * sp[17];
    A[116] = -0.1071428571428563 * sp[19] + 0.01934523809524032 * sp[18] + -0.0560515873015872 * sp[18] + 0.02182539682539814 * sp[17];
    A[117] = 0.2946278254943949 * sp[18] + 0.002805979290422863 * sp[18] + 0.1487169023924086 * sp[17];
    A[118] = -0.2061965247105818 * sp[19] + -0.1030982623552906 * sp[18] + -0.1030982623552908 * sp[18] + 0.1082531754730541 * sp[17];
    A[119] = -0.1458333333333371 * sp[18] + 0.004960317460317543 * sp[18] + -0.07043650793651005 * sp[17];
    A[120] = -0.0205853174603176 * sp[19] + 0.05820932539682571 * sp[18] + -0.007068452380952358 * sp[18] + 0.05114087301587341 * sp[17];
    A[121] = 0.02529761904761933 * sp[19] + -0.07524801587301648 * sp[18] + 0.01165674603174614 * sp[18] + -0.06111111111111168 * sp[17];
    A[122] = -0.0111607142857144 * sp[19] + 0.03266369047619068 * sp[18] + -0.006820436507936584 * sp[18] + 0.02385912698412713 * sp[17];
    A[123] = 0.01314484126984126 * sp[19] + 0.04382440476190486 * sp[18] + 0.004340277777777696 * sp[18] + 0.01116071428571426 * sp[17];
    A[124] = -0.01041666666666667 * sp[19] + -0.03358134920634917 * sp[18] + -0.006200396825396817 * sp[18] + -0.01190476190476187 * sp[17];
    A[125] = 0.01860119047619066 * sp[19] + 0.0430803571428574 * sp[18] + 0.009548611111111202 * sp[18] + 0.01860119047619052 * sp[17];
    A[126] = 0.04474206349206346 * sp[19] + 0.02237103174603172 * sp[18] + 0.02237103174603177 * sp[18] + 0.01765873015873017 * sp[17];
    A[127] = -0.09444444444444489 * sp[19] + -0.05466269841269866 * sp[18] + -0.0586309523809528 * sp[18] + -0.04871031746031779 * sp[17];
    A[128] = 0.1012896825396833 * sp[19] + 0.0685019841269847 * sp[18] + 0.0685019841269847 * sp[18] + 0.0573412698412704 * sp[17];
    A[129] = -0.1641497884897321 * sp[19] + -0.05822407027627445 * sp[18] + -0.0975077803421921 * sp[18] + -0.0350747411302858 * sp[17];
    A[130] = -0.2345485468582884 * sp[19] + -0.06142938132002937 * sp[18] + -0.1679642524204942 * sp[18] + -0.04209845712841176 * sp[17];
    A[131] = 0.2217261904761909 * sp[19] + 0.09945436507936549 * sp[18] + 0.1252480158730156 * sp[18] + 0.05109126984126969 * sp[17];
    A[132] = -0.04208968935634282 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732568 * sp[18] + -0.08979133729352924 * sp[17];
    A[133] = 0.1030982623552903 * sp[19] + 0.08763352300199788 * sp[18] + 0.02577456558882181 * sp[18] + -0.04639421805987987 * sp[17];
    A[134] = -0.07440476190476315 * sp[19] + -0.05902777777777945 * sp[18] + -0.02728174603174644 * sp[18] + -0.003968253968254307 * sp[17];
    A[135] = 0.04349267900155114 * sp[19] + -0.06243303921190627 * sp[18] + -0.02314932914598859 * sp[18] + 0.03507474113028557 * sp[17];
    A[136] = -0.07856742013183728 * sp[19] + 0.1360899955855054 * sp[18] + -0.009820927516479887 * sp[18] + 0.07014948226057133 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368425 * sp[18] + 0.01192541198429709 * sp[18] + -0.03507474113028568 * sp[17];
    A[138] = -0.0785674201318369 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901711 * sp[18] + 0.0420896893563428 * sp[17];
    A[139] = 0.148716902392409 * sp[19] + 0.2946278254943953 * sp[18] + 0.002805979290422788 * sp[18];
    A[140] = -0.08979133729352941 * sp[19] + -0.1950155606843834 * sp[18] + -0.01543288609732565 * sp[18] + -0.04208968935634277 * sp[17];
    A[141] = -0.2062394778460755 * sp[19] + -0.09329881140655705 * sp[18] + 0.04700015311458268 * sp[18] + 0.0350747411302855 * sp[17];
    A[142] = 0.1346870059402925 * sp[19] + 0.0659405133249347 * sp[18] + -0.07997040977705097 * sp[18] + -0.07014948226057102 * sp[17];
    A[143] = -0.1641497884897321 * sp[19] + -0.0975077803421921 * sp[18] + -0.05822407027627445 * sp[18] + -0.0350747411302858 * sp[17];
    A[144] = 4.920634920634906 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 0.3968253968254025 * sp[17];
    A[145] = 0.0243004934799691 * sp[19] + -0.06075123369997169 * sp[18] + 0.2308546880599298 * sp[18] + 0.607512336999805 * sp[17];
    A[146] = -0.519106168728203 * sp[19] + -0.8067190459965525 * sp[18] + -0.3016427737204508 * sp[18] + -0.3507474113028567 * sp[17];
    A[147] = -0.1984126984127016 * sp[19] + 4.305555555555532 * sp[18] + 0.01984126984126998 * sp[18] + -0.1984126984127008 * sp[17];
    A[148] = -0.2187044413199086 * sp[19] + -0.03645074021998757 * sp[18] + 0.2551551815399186 * sp[18] + -0.2187044413199259 * sp[17];
    A[149] = -0.3507474113028559 * sp[19] + 0.5401510134063873 * sp[18] + 0.0350747411302854 * sp[18] + 0.3226876183986337 * sp[17];
    A[150] = 0.06529556615835232 * sp[19] + -0.1271545235715237 * sp[18] + -0.05154913117764579 * sp[18] + 0.06529556615835085 * sp[17];
    A[151] = -0.05326743555023516 * sp[19] + 0.1838585678669348 * sp[18] + -0.0085915218629416 * sp[18] + 0.08419691425682245 * sp[17];
    A[152] = -0.003436608745177203 * sp[19] + -0.05154913117764433 * sp[18] + -0.01718304372588143 * sp[18] + -0.003436608745176603 * sp[17];
    A[153] = -0.03522523963805749 * sp[19] + 0.02104922856420367 * sp[18] + 0.07947157723220398 * sp[18] + 0.1159855451497028 * sp[17];
    A[154] = -0.006873217490354664 * sp[19] + -0.1778445025628795 * sp[18] + -0.047253370246175 * sp[18] + -0.103098262355291 * sp[17];
    A[155] = -0.02663371777511715 * sp[19] + -0.007302793583500541 * sp[18] + -0.01073940232867686 * sp[18] + -0.01288728279441236 * sp[17];
    A[156] = 0.131450284502998 * sp[19] + -0.01073940232867423 * sp[18] + 0.1576544261849666 * sp[18] + 0.1039574145415857 * sp[17];
    A[157] = 0.1030982623552917 * sp[19] + 0.1022391101689948 * sp[18] + -0.1520699369740541 * sp[18] + -0.1305911323167022 * sp[17];
    A[158] = -0.2345485468582884 * sp[19] + -0.1679642524204942 * sp[18] + -0.06142938132002937 * sp[18] + -0.04209845712841176 * sp[17];
    A[159] = 0.0243004934799691 * sp[19] + 0.2308546880599298 * sp[18] + -0.06075123369997169 * sp[18] + 0.607512336999805 * sp[17];
    A[160] = 5.416666666666708 * sp[19] + 0.4315476190476331 * sp[18] + 0.4315476190476331 * sp[18] + 1.130952380952398 * sp[17];
    A[161] = -0.1890134809847096 * sp[19] + -0.06873217490352254 * sp[18] + -0.2749286996141045 * sp[18] + -0.1890134809847019 * sp[17];
    A[162] = 0.1701034543599528 * sp[19] + 0.4495591293798421 * sp[18] + 0.1579532076199495 * sp[18] + -0.413108389159858 * sp[17];
    A[163] = -0.4017857142857217 * sp[19] + 3.593749999999993 * sp[18] + 0.558035714285723 * sp[18] + -0.4017857142857142 * sp[17];
    A[164] = 0.3007032652029488 * sp[19] + 0.1761261981902897 * sp[18] + 0.2792244605455824 * sp[18] + 0.3007032652029426 * sp[17];
    A[165] = -0.01686507936508141 * sp[19] + 0.0719246031746027 * sp[18] + -0.007440476190475746 * sp[18] + -0.01091269841269967 * sp[17];
    A[166] = -0.004960317460314796 * sp[19] + -0.1626984126984119 * sp[18] + 0.01984126984126904 * sp[18] + -0.1021825396825403 * sp[17];
    A[167] = 0.1001984126984121 * sp[19] + 0.1026785714285715 * sp[18] + -0.07192460317460356 * sp[18] + 0.1180555555555573 * sp[17];
    A[168] = -0.04513888888888812 * sp[19] + 0.005704365079364766 * sp[18] + 0.04340277777777803 * sp[18] + 0.05208333333333283 * sp[17];
    A[169] = 0.1289682539682538 * sp[19] + -0.0163690476190468 * sp[18] + -0.09176587301587376 * sp[18] + -0.1785714285714299 * sp[17];
    A[170] = -0.03819444444444252 * sp[19] + 0.1054067460317485 * sp[18] + 0.03596230158730127 * sp[18] + 0.1264880952380961 * sp[17];
    A[171] = 0.1473214285714276 * sp[19] + 0.04935515873015902 * sp[18] + 0.106894841269842 * sp[18] + 0.05605158730158804 * sp[17];
    A[172] = -0.1071428571428563 * sp[19] + -0.0560515873015872 * sp[18] + 0.01934523809524032 * sp[18] + 0.02182539682539814 * sp[17];
    A[173] = 0.2217261904761909 * sp[19] + 0.1252480158730156 * sp[18] + 0.09945436507936549 * sp[18] + 0.05109126984126969 * sp[17];
    A[174] = -0.519106168728203 * sp[19] + -0.3016427737204508 * sp[18] + -0.8067190459965525 * sp[18] + -0.3507474113028567 * sp[17];
    A[175] = -0.1890134809847096 * sp[19] + -0.2749286996141045 * sp[18] + -0.06873217490352254 * sp[18] + -0.1890134809847019 * sp[17];
    A[176] = 5.55555555555557 * sp[19] + 0.5902777777777783 * sp[18] + 0.5902777777777783 * sp[18] + 0.9126984126984293 * sp[17];
    A[177] = -0.3507474113028569 * sp[19] + -0.3016427737204449 * sp[18] + 0.2034334985556576 * sp[18] + -0.01402989645209509 * sp[17];
    A[178] = 0.07732369676647471 * sp[19] + 0.1675346763273471 * sp[18] + 0.06443641397205549 * sp[18] + 0.07732369676647141 * sp[17];
    A[179] = -0.6200396825396935 * sp[19] + 3.395337301587296 * sp[18] + 0.3596230158730228 * sp[18] + -0.620039682539702 * sp[17];
    A[180] = 0.03507474113028578 * sp[19] + -0.01192541198429711 * sp[18] + 0.1283735525368425 * sp[18] + -0.1248660784238148 * sp[17];
    A[181] = -0.07014948226057145 * sp[19] + 0.00982092751647989 * sp[18] + -0.1360899955855056 * sp[18] + 0.07856742013183692 * sp[17];
    A[182] = -0.03507474113028564 * sp[19] + 0.02314932914598861 * sp[18] + 0.06243303921190657 * sp[18] + -0.04349267900155106 * sp[17];
    A[183] = 0.03507474113028563 * sp[19] + 0.04700015311458285 * sp[18] + -0.09329881140655687 * sp[18] + -0.206239477846075 * sp[17];
    A[184] = -0.07014948226057141 * sp[19] + -0.07997040977705135 * sp[18] + 0.06594051332493447 * sp[18] + 0.1346870059402923 * sp[17];
    A[185] = -0.03507474113028564 * sp[19] + -0.05822407027627427 * sp[18] + -0.09750778034219186 * sp[18] + -0.1641497884897316 * sp[17];
    A[186] = 0.04208968935634283 * sp[19] + 0.02665680325901717 * sp[18] + -0.152925871328041 * sp[18] + -0.07856742013183682 * sp[17];
    A[187] = 0.002805979290422863 * sp[18] + 0.2946278254943949 * sp[18] + 0.1487169023924086 * sp[17];
    A[188] = -0.04208968935634282 * sp[19] + -0.01543288609732568 * sp[18] + -0.1950155606843832 * sp[18] + -0.08979133729352924 * sp[17];
    A[189] = -0.1984126984127016 * sp[19] + 0.01984126984126998 * sp[18] + 4.305555555555532 * sp[18] + -0.1984126984127008 * sp[17];
    A[190] = 0.1701034543599528 * sp[19] + 0.1579532076199495 * sp[18] + 0.4495591293798421 * sp[18] + -0.413108389159858 * sp[17];
    A[191] = -0.3507474113028569 * sp[19] + 0.2034334985556576 * sp[18] + -0.3016427737204449 * sp[18] + -0.01402989645209509 * sp[17];
    A[192] = 0.3968253968254036 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 4.920634920634909 * sp[17];
    A[193] = -0.1458029608799463 * sp[18] + -0.7290148043997469 * sp[18] + -0.4374088826398519 * sp[17];
    A[194] = 0.7014948226057137 * sp[19] + 0.3507474113028569 * sp[18] + 0.3507474113028572 * sp[18] + 0.2805979290422581 * sp[17];
    A[195] = -0.1005208057964095 * sp[19] + 0.07088005536926224 * sp[18] + -0.06314768569261553 * sp[18] + -0.08505606644311364 * sp[17];
    A[196] = 0.04639421805988031 * sp[19] + -0.01288728279441029 * sp[18] + 0.04897167461876184 * sp[18] + 0.03092947870658618 * sp[17];
    A[197] = -0.02319710902993958 * sp[19] + 0.0322182069860282 * sp[18] + 0.001288728279441132 * sp[18] + -0.01804219591217503 * sp[17];
    A[198] = 0.1005208057964093 * sp[19] + 0.1714008611656714 * sp[18] + 0.03737312010379379 * sp[18] + 0.1933092419161693 * sp[17];
    A[199] = -0.04639421805988019 * sp[19] + -0.0592815008542904 * sp[18] + 0.002577456558881516 * sp[18] + -0.04123930494211515 * sp[17];
    A[200] = 0.02319710902993945 * sp[19] + 0.05541531601596756 * sp[18] + 0.02448583730938063 * sp[18] + 0.07474624020758409 * sp[17];
    A[201] = 0.1030982623552902 * sp[19] + 0.07732369676646841 * sp[18] + 0.01546473935329262 * sp[18] + -0.05670404429540916 * sp[17];
    A[202] = -0.2061965247105818 * sp[19] + -0.1030982623552908 * sp[18] + -0.1030982623552906 * sp[18] + 0.1082531754730541 * sp[17];
    A[203] = 0.1030982623552903 * sp[19] + 0.02577456558882181 * sp[18] + 0.08763352300199788 * sp[18] + -0.04639421805987987 * sp[17];
    A[204] = -0.2187044413199086 * sp[19] + 0.2551551815399186 * sp[18] + -0.03645074021998757 * sp[18] + -0.2187044413199259 * sp[17];
    A[205] = -0.4017857142857217 * sp[19] + 0.558035714285723 * sp[18] + 3.593749999999993 * sp[18] + -0.4017857142857142 * sp[17];
    A[206] = 0.07732369676647471 * sp[19] + 0.06443641397205549 * sp[18] + 0.1675346763273471 * sp[18] + 0.07732369676647141 * sp[17];
    A[207] = -0.7290148043997469 * sp[18] + -0.1458029608799463 * sp[18] + -0.4374088826398519 * sp[17];
    A[208] = 0.8035714285714425 * sp[19] + 0.4017857142857212 * sp[18] + 0.4017857142857212 * sp[18] + 5.357142857142863 * sp[17];
    A[209] = -0.05154913117763665 * sp[18] + -0.2577456558882165 * sp[18] + -0.1546473935329269 * sp[17];
    A[210] = 0.06200396825396945 * sp[19] + -0.02108134920634952 * sp[18] + 0.09598214285714186 * sp[18] + 0.05307539682539828 * sp[17];
    A[211] = -0.1240079365079387 * sp[19] + 0.01736111111111123 * sp[18] + -0.2405753968253963 * sp[18] + 0.04365079365079537 * sp[17];
    A[212] = -0.06200396825396921 * sp[19] + 0.04092261904761981 * sp[18] + 0.1460813492063478 * sp[18] + -0.06498015873016071 * sp[17];
    A[213] = 0.06200396825396917 * sp[19] + 0.08308531746031883 * sp[18] + -0.03397817460317274 * sp[18] + 0.0401785714285746 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.1413690476190499 * sp[18] + 0.1165674603174582 * sp[18] + 0.1428571428571432 * sp[17];
    A[215] = -0.06200396825396917 * sp[19] + -0.1029265873015891 * sp[18] + -0.2080853174603166 * sp[18] + -0.3139880952380976 * sp[17];
    A[216] = 0.07440476190476314 * sp[19] + 0.04712301587301673 * sp[18] + 0.01537698412698315 * sp[18] + -0.007936507936507933 * sp[17];
    A[217] = 0.004960317460317543 * sp[18] + -0.1458333333333371 * sp[18] + -0.07043650793651005 * sp[17];
    A[218] = -0.07440476190476315 * sp[19] + -0.02728174603174644 * sp[18] + -0.05902777777777945 * sp[18] + -0.003968253968254307 * sp[17];
    A[219] = -0.3507474113028559 * sp[19] + 0.0350747411302854 * sp[18] + 0.5401510134063873 * sp[18] + 0.3226876183986337 * sp[17];
    A[220] = 0.3007032652029488 * sp[19] + 0.2792244605455824 * sp[18] + 0.1761261981902897 * sp[18] + 0.3007032652029426 * sp[17];
    A[221] = -0.6200396825396935 * sp[19] + 0.3596230158730228 * sp[18] + 3.395337301587296 * sp[18] + -0.620039682539702 * sp[17];
    A[222] = 0.7014948226057137 * sp[19] + 0.3507474113028572 * sp[18] + 0.3507474113028569 * sp[18] + 0.2805979290422581 * sp[17];
    A[223] = -0.2577456558882165 * sp[18] + -0.05154913117763665 * sp[18] + -0.1546473935329269 * sp[17];
    A[224] = 1.240079365079386 * sp[19] + 0.6200396825396923 * sp[18] + 0.6200396825396923 * sp[18] + 5.615079365079414 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "b83f641e7829e9c575d5a984f876a864e2f8433b0b78165abc1f7f4f758927c0fb3e9a8bdfa458345ddb9d155f956b09ab8a8cc210dc080640c57187112e0227";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "773d983dad5c072143f27ad99729ec1f21cc2553b8cd876de0398b83122d43ab9e73c14e34b6a6da6c75e8064a610f7218766161a04935bd3ce37befd98bc242";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
